/* Citadel/UX master program: all routines and login code. */

#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#ifdef BSD
#undef toupper
#undef tolower
#endif BSD
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <pwd.h>
#include <setjmp.h>
#ifdef BSD
#include <sgtty.h>
#else
#include <termio.h>
#endif BSD
#define CITADEL_C
#include "citadel.h"

#define IFEXPERT if (usersupp.flags&US_EXPERT)
#define IFNEXPERT if ((usersupp.flags&US_EXPERT)==0)
#define IFAIDE if (usersupp.flags&US_AIDE)
#define IFNAIDE if ((usersupp.flags&US_AIDE)==0)
struct passwd *getpwuid();
struct passwd *getpwnam();
char *getenv();
long atol();
long lseek();
long finduser();

char logname[50]; char fullname[100];
struct usersupp usersupp,USscratch;	/* Logged-in user's user supp */
struct quickroom quickroom,QRscratch;	/* Current room and scratch   */
struct fullroom fullroom;		/* Current room               */
struct smreturn smreturn;		/* For returning message numbers */
struct msgmain msgmain;			/* Global message info           */
struct voteinfo voteinfo;		/* temporary structure */
struct passwd *passwd;
int curr_rm;				/* Room NUMBER of current room.  */
int hold_rm;				/* Temporary room number */
					/* 0=Lobby 1=Mail 2=Aide 3-up=other */
char newnow;
char upass;				/* Nonzero if pw is managed by UNIX */
long yourpos;				/* position of your usersupp record */
char temp[50];				/* Name of general temp file */
int iaaroom;				/* Room num of IAA room (if enabled) */
#ifdef BSD
struct sgttyb stty0;			/* holds old tty settings */
#else
struct termio stty0;			/* holds old termio settings */
#endif BSD
char *pointer;
jmp_buf nextbuf;
int ugnum; long uglsn;			/* for <u>ngoto */

int (*backnext())() {
	signal(SIGINT,SIG_IGN);
	signal(SIGQUIT,SIG_IGN);
	longjmp(nextbuf,1);
	}

int (*backstop())() {
	signal(SIGQUIT,SIG_IGN);
	signal(SIGINT,SIG_IGN);
	longjmp(nextbuf,2);
	}

int (*sleeping())() {
	struct calllog temp;
	printf("Sleeping? Call again.\n");
	strcpy(temp.CLfullname,ttyname(0));
	temp.CLflags=CL_SLEEPING;
	rec_log(&temp);
	logoff(1); }

int (*dropcarr())() {
	struct calllog temp;
	strcpy(temp.CLfullname,ttyname(0));
	temp.CLflags=CL_DROPCARR;
	rec_log(&temp);
	logoff(SIGHUP);
}

inkey() {
	int a;
	signal(SIGALRM,(*sleeping));
	alarm(SLEEPING);
	a=getc(stdin); if (a==127) a=8;
#ifdef BSD
	if (a==10) a=13;
#endif BSD
	signal(SIGALRM,SIG_IGN);
	return(a);
	}

setsane() {
#ifdef BSD
	ioctl(0,TIOCSETP,&stty0);
#else
	ioctl(0,TCSETA,&stty0);
#endif BSD
	}

updatels() {	/* make all messages old in current room */
	int a;
	readyerself();
	storeug();
	for (a=0; a<MSGSPERRM; ++a)
		if (fullroom.FRnum[a]>usersupp.lastseen[curr_rm])
			usersupp.lastseen[curr_rm]=fullroom.FRnum[a];
	if (curr_rm==1) /* if mail room, do it a little differently... */
		usersupp.lastseen[1]=usersupp.mailnum[MAILSLOTS-1];
	writeyerself();
}

storeug() {	/* store <u>ngoto information */
	ugnum=curr_rm;
	uglsn=usersupp.lastseen[curr_rm];
	return(0); }

char *days[7]={
	"Sun","Mon","Tue","Wed","Thu","Fri","Sat" };

char *months[12]={
	"Jan","Feb","Mar","Apr","May","Jun",
	"Jul","Aug","Sep","Oct","Nov","Dec" };

formout(name) /* format a file to the screen using formout program */
char name[]; {
char aaa[100]; int a;
	strcpy(aaa,name);
	for (a=0; a<strlen(aaa); ++a) aaa[a]=tolower(aaa[a]);
	if (setjmp(nextbuf)!=0) { sttybbs(0); return(1); }
	signal(SIGINT,(*backnext));
	signal(SIGQUIT,(*backstop));
	sttybbs(1);
	fmout(usersupp.screenwidth,aaa);
	sttybbs(0);
	return(0);
}

userlist() /* prints the userlist */ {
	printf("USER LIST (ctrl-s to pause, ctrl-c to abort)\n");
	system("userlist");
}

getline(string,lim)	/* Gets a line from the terminal */
char string[]; 		/* Pointer to string buffer */
int lim;		/* Maximum length - if negative, no-show */
{
int a,b; char flag;
#ifdef	BSD
	setjmp(nextbuf);
#endif	BSD
	flag=0;
	if (lim<0) { lim=(0-lim); flag=1; }
	strcpy(string,"");
GLA:	a=inkey(); a=(a&127);
	if ((a==8)&&(strlen(string)==0)) goto GLA;
	if ((a!=13)&&(a!=8)&&(strlen(string)==lim)) {
		putc('<',stdout); putc(8,stdout);
		putc(32,stdout); putc(8,stdout); goto GLA; }
	if ((a==8)&&(string[0]!=0)) {
		string[strlen(string)-1]=0;
		putc(8,stdout); putc(32,stdout); putc(8,stdout); goto GLA; }
	if ((a==13)||(a==10)) {
		putc(13,stdout); putc(10,stdout); return(0); }
	b=strlen(string);
	string[b]=a;
	string[b+1]=0;
	if (flag==0) putc(a,stdout);
	if (flag==1) putc('*',stdout);
	goto GLA;
}

strcase(string)	/* Case-converts a string */
char string[]; {
	int a,b,c;
	b=0; c=0;
	for (a=0; a<strlen(string); ++a) {
		if (islower(string[a])) ++b;
		if (isupper(string[a])) ++c; }
	if ((b!=0)&&(c!=0)) return(0);
	for (a=0; a<strlen(string); ++a) {
		string[a]=toascii(string[a]);
		string[a]=tolower(string[a]); }
	string[0]=toupper(string[0]);
	for (a=1; a<strlen(string); ++a) {
		if (isspace(string[a-1])) string[a]=toupper(string[a]);
		}
	return(0);
}

readmail()
{
	int a;
	readyerself();
	for (a=0; a<MSGSPERRM; ++a) {
		fullroom.FRnum[a]=0L;
		fullroom.FRpos[a]=0L; }
	for (a=0; a<MAILSLOTS; ++a) {
		fullroom.FRnum[a+(MSGSPERRM-MAILSLOTS)]=usersupp.mailnum[a];
		fullroom.FRpos[a+(MSGSPERRM-MAILSLOTS)]=usersupp.mailpos[a]; }
}

writemail()
{
	int a;
	readyerself();
	for (a=0; a<MAILSLOTS; ++a) {
		usersupp.mailnum[a]=fullroom.FRnum[a+(MSGSPERRM-MAILSLOTS)];
		usersupp.mailpos[a]=fullroom.FRpos[a+(MSGSPERRM-MAILSLOTS)]; }
	writeyerself();
}

readyerself()
{
	int file;
	file=open("usersupp",O_RDONLY);
	if (file<0) interr(4);
	lseek(file,yourpos,0);
	do {
	       read(file,&usersupp,sizeof(struct usersupp));
	       if (strucmp(fullname,usersupp.fullname)) finduser(file,fullname);
		} while(strucmp(fullname,usersupp.fullname));
	close(file);
	return(0);
}

writeyerself()
{
	int file;
	struct usersupp me;
	file=open("usersupp",O_RDWR);
	if (file<0) interr(6);
	lseek(file,yourpos,0);
	read(file,&me,sizeof(struct usersupp));
	if (me.eternal!=usersupp.eternal)
		yourpos=finduser(file,usersupp.fullname);
	lseek(file,yourpos,0);
	write(file,&usersupp,sizeof(struct usersupp));
	close(file);
	return(0);
}

main()
{

int a,b,c,d,e,f;
long aa,cc,ee;
char buf[300];
char aaa[100],bbb[100];
char ccc[100],eee[100];	/* general purpose variables */
char skipping[MAXROOMS];
FILE *fp;
int file,file2;
struct usersupp tempUS;
struct filecomment filecomment;
struct calllog calllog;
char mtsflag;

#ifdef BSD
ioctl(0,TIOCGETP,&stty0);	/* Store the old terminal parameters and */
#else
ioctl(0,TCGETA,&stty0);		/* Store the old terminal parameters and */
#endif BSD
sttybbs(0);			/* install the new ones                  */
signal(SIGINT,SIG_IGN);
signal(SIGQUIT,SIG_IGN);
signal(SIGHUP,(*dropcarr));
printf("\n%s\n",PGMNAME);
usersupp.screenwidth=40;
formout("messages/hello");
usersupp.screenwidth=80;

log_carr();
a=getuid();
passwd=(struct passwd *)getpwuid(a);
strcpy(logname,passwd->pw_name);
strcpy(fullname,passwd->pw_gecos);
upass=1; if (a==BBSUID) upass=0;
#ifdef BSD
for (a=0; a<strlen(fullname); ++a) if (fullname[a]==';') fullname[a]=0;
#endif BSD

/* if IAA detection enabled, get a value for iaaroom */
if (IAADETECT) {
	iaaroom=2; /* use the Aide> room if IAAROOM isn't found */
	file=open("quickroom",O_RDONLY); if (file<0) interr(84);
	for (a=0; a<MAXROOMS; ++a) {
		b=read(file,&quickroom,sizeof(struct quickroom));
		if (b<1) interr(85);
		if ((!strucmp(quickroom.QRname,IAAROOM))
		   &&((quickroom.QRflags&QR_INUSE)==QR_INUSE)) iaaroom=a;
		}
	close(file);
}

GSTA:	if (upass==0) {				/* guest account - find out */
GSTB:		printf("Enter your name: ");	/* who the user is          */
		getline(fullname,29);
		strproc(fullname); strcase(fullname);
		if (!strucmp(fullname,"new")) goto GSTB;
		if (strlen(fullname)==0) goto GSTB;
		}

			/* get the usersupp data for guest account */
if (upass==0) {
	file=open("usersupp",O_RDONLY);
	yourpos=finduser(file,fullname);
	if (yourpos==(-1L)) { close(file); goto NEWUSR; }
	read(file,&usersupp,sizeof(struct usersupp));
	close(file);
	goto USOK;
	}

if (upass==1) {		/* get the usersupp data for shell account */
	file=open("usersupp",O_RDONLY);
	if (file<0) interr(25);
	do {
		yourpos=lseek(file,0L,1);
		a=read(file,&usersupp,sizeof(struct usersupp));
		} while((strucmp(usersupp.logname,logname))&&(a>1));
	close(file);
	if (a>1) goto USOK;
	}

NEWUSR:	if (upass==0) {
#ifdef	BSD
		if (taboo(fullname)) {
			printf("Sorry, but \"%s\" is not allowed.\n",fullname);
			goto GSTA;
		}
#endif	BSD
		printf("No record.  Enter as new user? ");
		if (yesno()==0) goto GSTA;
		}

	strcpy(usersupp.logname,logname);
	strcpy(usersupp.fullname,fullname);
	for (a=0; a<MAXROOMS; ++a) {	usersupp.lastseen[a]=0L;
					usersupp.generation[a]=(-1);
					usersupp.forget[a]=(-1); }
	for (a=0; a<MAILSLOTS; ++a) {	usersupp.mailnum[a]=0L;
					usersupp.mailpos[a]=0L; }
	for (a=0; a<NVOTES; ++a) 	usersupp.votegens[a]=(-1);
	usersupp.flags=0;
	usersupp.timescalled=0;
	usersupp.posted=0;
	time(&aa);
	usersupp.lastcall=aa;
	getusinfo(&usersupp);
	
	if (upass==0) {
		IFNEXPERT formout("messages/changepw");
		printf("Please enter a password: ");
		getline(usersupp.password,19);
		newnow=1;
		}

	file=open("eternal",O_RDWR);	/* get a new user number */
	read(file,&aa,4);
	usersupp.eternal=aa;
	aa=aa+1L;
	lseek(file,0L,0);
	write(file,&aa,4);
	close(file);

	printf("  (wait)\n");
						/* Add user to the        */
	file=open("usersupp",O_RDONLY);		/* usersupp file, keeping */
	file2=creat("/tmp/usersupp",0666);	/* the file in            */
	b=0;					/* alphabetical order     */
	do {
		a=read(file,&tempUS,sizeof(struct usersupp));
		if ( (strucmp(usersupp.fullname,tempUS.fullname)<0) ||(a<1)) {
			if (b==0)write(file2,&usersupp,sizeof(struct usersupp));
		 	b=1;
			}
		if (a>0) write(file2,&tempUS,sizeof(struct usersupp));
		} while(a>0);
	yourpos=finduser(file2,usersupp.fullname);
	close(file); close(file2);
	system("mv /tmp/usersupp usersupp");
	chmod("usersupp",0666);
	strcpy(calllog.CLfullname,usersupp.fullname);
	calllog.CLflags=CL_NEWUSER;
	rec_log(&calllog);

USOK:	/* make sure that if it's a shell user, they log in from the shell */
	if (upass==0) if ((getpwnam(usersupp.logname)->pw_uid)!=BBSUID) {
	printf("Please log in by running Citadel from the shell.\n");
	printf("(press any key to continue)\n");
	inkey();
	logoff(0); }

if ((upass==0)&&(newnow==0)) {
	printf("\rPlease enter your password: ");
	getline(eee,-19);
	if (!strucmp(eee,usersupp.password)) goto PWOK;
	printf("Wrong password...\n");
	strcpy(calllog.CLfullname,usersupp.fullname);
	calllog.CLflags=CL_BADPW;
	rec_log(&calllog);
	goto GSTA;
	}

/* A room's generation number changes each time it is recycled. Users are kept
 * out of private rooms or forget rooms by matching the generation numbers. To
 * avoid an accidental matchup, unmatched numbers are set to -1 here.
 */
PWOK:	readyerself();
	strcpy(fullname,usersupp.fullname);
	strcpy(logname,usersupp.logname);
	++usersupp.timescalled;
	time(&aa);
	usersupp.lastcall=aa;
	file=open("quickroom",O_RDONLY);
	if (file<0) interr(28);
	for (a=0; a<MAXROOMS; ++a) {
		b=read(file,&quickroom,sizeof(struct quickroom));
if (usersupp.generation[a] != quickroom.QRgen) usersupp.generation[a]=(-1);
if (usersupp.forget[a] != quickroom.QRgen) usersupp.forget[a]=(-1);
		}
	close(file);
	writeyerself();
	ugnum=(-1);

	strcpy(calllog.CLfullname,usersupp.fullname);
	time(&calllog.CLtime);
	calllog.CLflags=CL_LOGIN;
	rec_log(&calllog);

	IFAIDE printf("<aide> ");
	printf("%s, call #%d       \n",usersupp.fullname,usersupp.timescalled);

	b=0;				/* check for mail */
	for (a=0; a<MAILSLOTS; ++a)
	if (usersupp.mailnum[a]>usersupp.lastseen[1]) ++b;
	if (b==1) printf("*** You have a new private message in Mail>\n");
	if (b>1)  printf("*** You have %d new private messages in Mail>\n",b);

	sprintf(temp,"/tmp/Cit%d",getpid()); /* make up a temp file name */

	/* Enter the lobby */
	file=open("quickroom",O_RDONLY); if (file<0) interr(30);
	a=read(file,&quickroom,sizeof(struct quickroom));
	close(file);
	file=open("./rooms/fullrm0",O_RDONLY); if (file<0) interr(32);
	a=read(file,&fullroom,sizeof(struct fullroom));
	close(file);

/* Main part of the system... user is logged in. */
	for (a=0; a<MAXROOMS; ++a) skipping[a]=0;
	strcpy(aaa,"n"); goto MAINFAKE;
MAIN:	signal(SIGINT,SIG_IGN);
	signal(SIGQUIT,SIG_IGN);
	a='>'; if ((quickroom.QRflags)&QR_DIRECTORY) a=']';
	if (quickroom.QRflags&QR_NETWORK) a=')';
	printf("\n%s%c ",quickroom.QRname,a); /* room prompt */
	getcmd(aaa);
MAINFAKE:
if (!strcmp(aaa,"h"))				goto HELP;
if (!strcmp(aaa,".ep"))				goto PASSWD;
if (!strncmp(aaa,".h",2))			goto HELPFILE;
if (!strncmp(aaa,".g",2)) { updatels();		goto DOTGOTO; }
if (!strcmp(aaa,"g")) { updatels();		goto THEGOTO; }
if (!strcmp(aaa,"k"))				goto KNROOMS;
if (!strcmp(aaa,".z"))				goto ZLIST;
if (!strcmp(aaa,"e")) {		e=0;	c=0;	goto ENTMSG; }
if (!strcmp(aaa,".ea")) {	e=0;	c=1;	goto ENTMSG; }
if (!strcmp(aaa,"z"))				forget();
if (!strcmp(aaa,"f")) { b=0;		c=0;	goto RFWD; }
if (!strcmp(aaa,"l")) { b=MSGSPERRM-5;	c=0;	goto RFWD; }
if (!strcmp(aaa,"n")) { b=0;		c=1;	goto RFWD; }
if (!strcmp(aaa,"r")) { 		c=0;	goto VFWD; }
if (!strcmp(aaa,"o")) {			c=1;	goto VFWD; }
if (!strcmp(aaa,".er")) { updatels();		entroom(); }
if (!strcmp(aaa,".ak"))				killroom();
if (!strcmp(aaa,".ru"))				userlist();
if (!strcmp(aaa,".ari"))			invite();
if (!strcmp(aaa,".ark"))			kickout();
if (!strcmp(aaa,".ae"))				editroom();
if (!strcmp(aaa,"d"))				roomdir();
if (!strcmp(aaa,".rt"))				download(0);
if (!strcmp(aaa,".rx"))				download(1);
if (!strcmp(aaa,".rf"))				download(2);
if (!strcmp(aaa,".et")) { c=0;			goto ENTERTEXT; }
if (!strcmp(aaa,".ex")) { c=1;			goto ENTERTEXT; }
if (!strcmp(aaa,"u"))				ungoto();
if (!strcmp(aaa,".rv"))				readvote();
if (!strcmp(aaa,".ev"))				entervote();
if (!strcmp(aaa,".aw"))				whoknows();

if (!strcmp(aaa,"*")) {
	setsane();
	sprintf(aaa,"subsystem %ld %d",usersupp.eternal,usersupp.screenwidth);
	system(aaa);
	sttybbs(0);
	}

if (!strcmp(aaa,".tq")) {	updatels();	goto TERMINATE; }
if (!strcmp(aaa,"t")) {
	printf("Are you sure (y/n)? ");
	if (yesno()==1) {
		updatels();
		goto TERMINATE;
		}
	}

if (!strcmp(aaa,"s")) {
	storeug();
	skipping[curr_rm]=1;
	goto THEGOTO;
	}

if (!strcmp(aaa,"c")) {
	a=fork();
	if (a==0) {
		execlp("chat","",usersupp.fullname,NULL);
		printf("Chat program not available.\n");
#ifdef BSD
		_exit(0); }
	(void) wait(0);
#else
		exit(0); }
	wait();
#endif BSD
	}

if (!strcmp(aaa,".as")) {
	printf("\nShell cmd: ");
	getline(aaa,99);
	setsane();
	system(aaa);
	sttybbs(0);
	}

if (!strcmp(aaa,".ec")) {
	readyerself();
	getusinfo(&usersupp);
	writeyerself();
	}

if (!strcmp(aaa,".au")) {
	file=open("usersupp",O_RDWR);
	printf("User name: ");
	getline(aaa,29);
	aa=finduser(file,aaa);
	if (aa!=(-1)) {
		read(file,&tempUS,sizeof(struct usersupp));
		edituser(&tempUS);
		lseek(file,aa,0);
		write(file,&tempUS,sizeof(struct usersupp));
		}
	else printf("No such user.\n");
	close(file);
	}

goto MAIN;

ENTERTEXT:
	if ( (quickroom.QRflags&QR_DIRECTORY==0)
		|| (quickroom.QRflags&QR_UPLOAD==0) ) {
			printf("Not in this room.\n");
			goto MAIN;
			}

	printf("Enter filename: ");
	getline(aaa,15);
	for (a=0; a<strlen(aaa); ++a) aaa[a]=tolower(aaa[a]);
	sprintf(bbb,"./files/%s/%s",quickroom.QRdirname,aaa);
	file=open(bbb,O_RDONLY);
	if (file>(-1)) {
		printf("There already is a file by that name.\n");
		close(file); goto MAIN; }
	printf("Enter a short description of the file:\n: ");
	getline(buf,150);
	sprintf(ccc,"./files/%s/filedir",quickroom.QRdirname);
	file=open(ccc,O_RDWR);
	if (file<0) file=creat(ccc,0666); chmod(ccc,0666);
	do {
		a=read(file,&filecomment,sizeof(struct filecomment));
		} while ((a>0)&&(strucmp(filecomment.FCname,buf)));
	if (!strucmp(filecomment.FCname,buf))
		lseek(file,(0L-sizeof(struct filecomment)),1);

	strcpy(filecomment.FCname,aaa);
	strcpy(filecomment.FCcomment,buf);
	write(file,&filecomment,sizeof(struct filecomment));
	close(file);
	file=creat(bbb,0666);
	if (file<0) {
		printf("Can't create that file?\n");
		goto MAIN; }
	if (c==1) goto ETUX;
	a=0;
	printf("Now recieving. ESC to end.\n");
	do {
		b=inkey(); 
		if (b==13) { b=10; printf("\r"); }
		if (b!=27) { printf("%c",b); write(file,&b,1); }
		} while(b!=27);
	close(file);
ETPRF:	printf("File recieved.\n");
	time(&cc);
	fp=fopen(temp,"wb"); if (fp==NULL) interr(22);
	putc(255,fp);
	putc(MES_NORMAL,fp);
	putc(0,fp);
	fprintf(fp,"T%ld",cc); putc(0,fp);
	fprintf(fp,"A%s",usersupp.fullname); putc(0,fp);
	fprintf(fp,"O%s",quickroom.QRname); putc(0,fp); putc('M',fp);
	fprintf(fp,"*New Upload*\nFilename: %s\r %s\n",
		filecomment.FCname,filecomment.FCcomment);
	putc(0,fp);
	fclose(fp);
	goto EPOINT;
ETUX:	close(file);
#ifdef BSD
	Xupload(bbb);		/* use protocol based upload */
#else
	sprintf(aaa,"wcrecieve %s",bbb);
	system(aaa);
#endif BSD
	goto ETPRF;



RFWD:	/* routine for read forward, read new, read last five messages */
	signal(SIGINT,SIG_IGN);
	signal(SIGQUIT,SIG_IGN);
	cc=usersupp.lastseen[curr_rm]+1L;
	if (usersupp.flags & US_LASTOLD) --cc;
	file=open("./MMstructure",O_RDONLY);
	if (file<0) interr(44);
	a=read(file,&msgmain,sizeof(struct msgmain)); if (a<1) interr(45);
	close(file);

	for (a=b; a<MSGSPERRM; ++a) {
		if (fullroom.FRnum[a]==0L) goto RNEXT;
		if (fullroom.FRnum[a]<msgmain.MMlowest) goto RNEXT;
		if ( (c==1) && (fullroom.FRnum[a]<cc) ) goto RNEXT;
RAGAIN:		e=read_message(fullroom.FRpos[a]);
		if (e==1) goto RNEXT;
		if (e==2) goto RSTOP;
		if (usersupp.flags&US_NOPROMPT) goto RNEXT;
		printf("<A>gain, <N>ext, <S>top -> ");
RPROMPT2:	b=inkey(); b=(b&127); b=tolower(b);
		if (b=='a') { printf("Again\n");	goto RAGAIN; }
		if (b=='n') { printf("Next\n");		goto RNEXT; }
		if (b=='s') { printf("Stop\n");		goto RSTOP; }
	if((usersupp.flags&US_AIDE)||(usersupp.eternal==quickroom.QRroomaide))
		if ((b=='d')&&(curr_rm!=1)) {
			printf("Delete\n");
			goto RDELETE;
			}
		goto RPROMPT2;
RNEXT:		b=b;             }
RSTOP:		goto MAIN;
RDELETE:	printf("---> Delete this message? ");
		if (yesno()==1) delete_message(fullroom.FRnum[a]);
		goto RNEXT;

VDELETE:	printf("---> Delete this message? ");
		if (yesno()==1) delete_message(fullroom.FRnum[a]);
		goto VNEXT;

VFWD:		/* routine for read reverse */
		signal(SIGINT,SIG_IGN);
		signal(SIGQUIT,SIG_IGN);
		cc=usersupp.lastseen[curr_rm]+1L;
		file=open("./MMstructure",O_RDONLY);
		if (file<0) interr(46);
	a=read(file,&msgmain,sizeof(struct msgmain)); if (a<1) interr(47);
		close(file);

		for (a=(MSGSPERRM-1); a>=0; --a) {
		if ( (c==1) && (fullroom.FRnum[a]>cc) ) goto VNEXT;
		if (fullroom.FRnum[a]==0L) goto VNEXT;
VAGAIN:		e=read_message(fullroom.FRpos[a]);
		if (e==1) goto RNEXT;
		if (e==2) goto RSTOP;
		if (usersupp.flags & US_NOPROMPT) goto VNEXT;
		printf("<A>gain, <N>ext, <S>top -> ");
VPROMPT2:	b=inkey(); b=(b&127); b=tolower(b);
		if (b=='a') { printf("Again\n");	goto VAGAIN; }
		if (b=='n') { printf("Next\n");		goto VNEXT; }
		if (b=='s') { printf("Stop\n");		goto RSTOP; }
	if((usersupp.flags&US_AIDE)||(usersupp.eternal==quickroom.QRroomaide))
		if ((b=='d')&&(curr_rm!=1))
			{ printf("Delete\n"); goto VDELETE; }
		goto VPROMPT2;
VNEXT:		b=b;                }

ENTMSG:
	if ((usersupp.flags&US_NONET)&&(quickroom.QRflags&QR_NETWORK)) {
		printf("Need net privileges to enter here\n");
		goto MAIN;
		}
	mtsflag=0;
	hold_rm=curr_rm;
	IFNEXPERT formout("messages/entermsg");
		
	if (curr_rm==1) {
		printf("Enter recipient: ");
		getline(buf,299);
		alias(buf);
		if (buf[0]==0) goto MAIN;
	if (!strucmp(buf,"sysop")) { mtsflag=1; goto SKFALL; }
	for (a=0; a<strlen(buf); ++a) if (buf[a]=='!') e=1;
	if (e==1) goto SKFALL;	/* set e to 1 for a uucp message */
	if (!strucmp(buf,usersupp.fullname)) {
		printf("Can't send mail to yourself!\n");
		goto MAIN; }

	file=open("usersupp",O_RDONLY);		/* check to make sure the */
	aa=finduser(file,buf);			/* user exists; also get  */
	if (aa==(-1)) {				/* the right upper/lower  */
		printf("No such user.\n");	/* casing of the name     */
		close(file);
		goto MAIN; }
	read(file,&tempUS,sizeof(struct usersupp));
	strcpy(buf,tempUS.fullname);
	close(file);
}

SKFALL: b=MES_NORMAL; if (quickroom.QRflags&QR_ANONONLY) b=MES_ANON;
	if (quickroom.QRflags&QR_ANON2) {
		printf("Anonymous (Y/N)? ");
		if (yesno()==1) b=MES_AN2;
		}
	if (curr_rm!=1) buf[0]=0;
	a=make_message(temp,&usersupp,buf,quickroom.QRname,b,c);
	if (a==2) goto MAIN;
EPOINT:	send_message(temp,&smreturn);
	hold_rm=(-1);
	if (IAADETECT) if ((usersupp.flags&US_TWIT)&&(curr_rm!=1)) {
		hold_rm=curr_rm;
		curr_rm=iaaroom;
		gotocurr(); }
	if (mtsflag) {
		hold_rm=curr_rm;
		curr_rm=2;
		gotocurr(); }
	sprintf(aaa,"./rooms/fullrm%d",curr_rm);
	file=open(aaa,O_RDWR); if (file<0) interr(48);
	a=read(file,&fullroom,sizeof(struct fullroom)); if (a<1) interr(49);
	if (curr_rm==1) readmail();
	for (a=0; a<(MSGSPERRM-1); ++a) {
		fullroom.FRnum[a]=fullroom.FRnum[a+1];
		fullroom.FRpos[a]=fullroom.FRpos[a+1];
		}
	fullroom.FRnum[MSGSPERRM-1]=smreturn.smnumber;
	fullroom.FRpos[MSGSPERRM-1]=smreturn.smpos;
	lseek(file,0L,0);
	a=write(file,&fullroom,sizeof(struct fullroom)); if (a<1) interr(50);
	close(file);

	file=open("quickroom",O_RDWR); if (file<0) interr(51);
	aa=(long)(curr_rm * sizeof(struct quickroom));
	lseek(file,aa,0);
	a=read(file,&quickroom,sizeof(struct quickroom)); if (a<1) interr(52);
	quickroom.QRhighest=fullroom.FRnum[MSGSPERRM-1];
	lseek(file,aa,0);
	a=write(file,&quickroom,sizeof(struct quickroom)); if (a<1) interr(53);
	close(file);
	readyerself(); ++usersupp.posted; writeyerself();
	if (curr_rm!=1) goto ENTFIN;	/* if mail, there's still more to do */
	writemail();			/* keep a copy for yourself */
	if (mtsflag) goto ENTFIN;
	if (e==1) {
		a=fork();
		if (a>0) wait();
		if (a==0) {
			execl("uucitamail","uucitamail",temp);
			exit(0);
			}
		}
	file=open("usersupp",O_RDWR); if (file<0) interr(54);
	ee=finduser(file,buf);
	if (ee!=(-1L)) {
		d=read(file,&tempUS,sizeof(struct usersupp));
		for (e=0; e<(MAILSLOTS-1); ++e) {
			tempUS.mailnum[e]=tempUS.mailnum[e+1];
			tempUS.mailpos[e]=tempUS.mailpos[e+1];
			}
		tempUS.mailnum[MAILSLOTS-1]=smreturn.smnumber;
		tempUS.mailpos[MAILSLOTS-1]=smreturn.smpos;
		lseek(file,ee,0);
		write(file,&tempUS,sizeof(struct usersupp)); 
		}
	close(file);

ENTFIN:	if (IAADETECT) if (hold_rm!=(-1)) {
		curr_rm=hold_rm;
		gotocurr(); }
	if (mtsflag) { curr_rm=hold_rm; gotocurr(); }
	unlink(temp);
	goto MAIN;


THEGOTO:	/* goto next room having unread messages */
	curr_rm=0; f=1;
	if (usersupp.mailnum[MAILSLOTS-1]>usersupp.lastseen[1]) {
		curr_rm=1; goto DGFOUNDIT; } /* mail comes first */
	file=open("quickroom",O_RDONLY); if (file<0) interr(55);
	for (a=0; a<2; ++a) read(file,&QRscratch,sizeof(struct quickroom));
					/* ^skip Lobby and Mail */
	for (a=2; a<MAXROOMS; ++a) {
		d=read(file,&QRscratch,sizeof(struct quickroom));
		if (d<1) interr(56);
		if ((QRscratch.QRflags & QR_INUSE)
			&& (QRscratch.QRhighest>usersupp.lastseen[a])
			&& (QRscratch.QRgen != usersupp.forget[a])
			&& (	((QRscratch.QRflags&QR_PRIVATE)==0)
   			||	((usersupp.flags&US_AIDE)==US_AIDE)
   			|| (QRscratch.QRgen==usersupp.generation[a])
   			)
			&& (skipping[a]==0)
			&& ( (a!=2) || ((usersupp.flags&US_AIDE)==US_AIDE) )
			) {
				curr_rm=a;
				goto FRWUR;
				}
		}
FRWUR:	close(file);
	b=0;
	for (c=0; c<MAXROOMS; ++c) if (skipping[c]>0) ++b;
	if ( (curr_rm==0) && (b>0) ) {
		for (c=0; c<MAXROOMS; ++c) skipping[c]=0;
		curr_rm=0; printf("---> You have skipped rooms.\n");
		}
	goto DGFOUNDIT;

KNROOMS:
	e=setjmp(nextbuf);
	if (e==0) {
		signal(SIGINT,(*backnext));
		signal(SIGQUIT,(*backstop));
		sttybbs(1);
		knrooms(&usersupp);
		}
	sttybbs(0);
	signal(SIGINT,SIG_IGN);
	signal(SIGQUIT,SIG_IGN);
	printf("\n");
	goto MAIN;

ZLIST:
	e=setjmp(nextbuf);
	if (e==0) {
		signal(SIGINT,(*backnext));
		signal(SIGQUIT,(*backstop));
		sttybbs(1);
		listzrooms(&usersupp);
		}
	sttybbs(0);
	signal(SIGINT,SIG_IGN);
	signal(SIGQUIT,SIG_IGN);
	printf("\n");
	goto MAIN;

DOTGOTO:	/* .Goto a new room */
	f=0;	/* flag for dgfoundit */
	strcpy(aaa,&aaa[2]);
	for (a=0; a<strlen(aaa); ++a) aaa[a]=tolower(aaa[a]);
	IFNAIDE if(!strucmp(aaa,"aide")) {
		printf("You're not an aide.\n");
		goto MAIN;
		}

	file=open("quickroom",O_RDONLY); if (file<0) interr(72);
	c=0;
	for (a=0; a<MAXROOMS; ++a) {
		d=read(file,&QRscratch,sizeof(struct quickroom));
		if (d<1) interr(73);
		strcpy(bbb,QRscratch.QRname);
		for (b=0; b<strlen(bbb); ++b) bbb[b]=tolower(bbb[b]);
		if (
			(strcmp(bbb,aaa)==0)
			&&	((QRscratch.QRflags&QR_INUSE)!=0)
			&& (	((QRscratch.QRflags&QR_PRIVATE)==0)
   			|| ((QRscratch.QRflags&QR_GUESSNAME)==QR_GUESSNAME)
   			|| ((QRscratch.QRflags&QR_PASSWORDED)==QR_PASSWORDED)
   			||	(QRscratch.QRgen==usersupp.generation[a])
			||	((usersupp.flags&US_AIDE)==US_AIDE)
   			)
		)
	{
	close(file);
	if (  (QRscratch.QRflags&QR_PASSWORDED) &&
		(QRscratch.QRgen!=usersupp.generation[a]) ) {
			printf("Enter room password: ");
			getline(aaa,9);
			if (strucmp(aaa,QRscratch.QRpasswd)) {
			   printf("Wrong password.\n"); goto MAIN; } }
 		curr_rm=a; goto DGFOUNDIT; }
		}

	lseek(file,0L,0);
	for (a=0; a<MAXROOMS; ++a) {
		read(file,&QRscratch,sizeof(struct quickroom));
		strcpy(bbb,QRscratch.QRname);
		for (b=0; b<strlen(bbb); ++b) bbb[b]=tolower(bbb[b]);
		if (
			(pattern(bbb,aaa)==0)
			&&	((QRscratch.QRflags&QR_INUSE)!=0)
			&& (	((QRscratch.QRflags&QR_PRIVATE)==0)
   			||	(QRscratch.QRgen==usersupp.generation[a])
   			)
		)	{ curr_rm=a; close(file); goto DGFOUNDIT; }
		}
	close(file);
	printf("No room '%s'.\n",aaa);
	goto MAIN;

DGFOUNDIT:	/* goto room currently in main() variable curr_rm */
	gotocurr();
	b=0; c=0;
	for (a=0; a<MSGSPERRM; ++a) {
		if (fullroom.FRnum[a]>0L)
		if (fullroom.FRnum[a]>=msgmain.MMlowest)
	{	++b;
		if (fullroom.FRnum[a]>usersupp.lastseen[curr_rm]) ++c;
	} }
	if (f==1) printf("\042%s\042\n",quickroom.QRname);
	printf("%d messages, %d new\n",b,c);
	readyerself();
	usersupp.forget[curr_rm]=(-1);
	usersupp.generation[curr_rm]=quickroom.QRgen;
	writeyerself();
	skipping[curr_rm]=0;
	goto MAIN;

HELPFILE:
	sprintf(bbb,"help/%s",&aaa[2]);
	formout(bbb);
	goto MAIN;

TERMINATE:
	formout("messages/goodbye");
	strcpy(calllog.CLfullname,ttyname(0));
	calllog.CLflags=CL_TERMINATE;
	rec_log(&calllog);
	printf("%s logged out.\n",fullname);
	logoff(0);

HELP:	formout("messages/help");
	goto MAIN;

	/* will only change password if it's maintained by Citadel */
PASSWD:	if (upass!=0) {
		printf("Use the shell 'passwd' command.\n");
		goto MAIN; }
	IFNEXPERT formout("messages/changepw");
	printf("Enter new password: ");
	getline(ccc,19);
	if (ccc[0]==0) {
		printf("Password unchanged.\n");
		goto MAIN; }
	readyerself();
	strcase(ccc);
	strcpy(usersupp.password,ccc);
	writeyerself();
	printf("Password changed.\n");
	goto MAIN;

}

delete_message(delnum) /* Delete message from current room */
long delnum; {
	int file,a,b;
	char aaa[100];
	if (curr_rm==1) {
		printf("Can't delete mail.\n");
		return(1); }
	sprintf(aaa,"./rooms/fullrm%d",curr_rm);
	file=open(aaa,O_RDWR);
	if (file<0) interr(78);
	a=read(file,&fullroom,sizeof(struct fullroom));
	if (a<1) interr(79); 
	for (a=0; a<MSGSPERRM; ++a)
		if (fullroom.FRnum[a]==delnum) {
			fullroom.FRnum[a]=0L;
			fullroom.FRpos[a]=0L; }
	lseek(file,0L,0);
	a=write(file,&fullroom,sizeof(struct fullroom));
	if (a<1) interr(80);
	close(file);
	file=open("./quickroom",O_RDWR); if (file<0) interr(81);
	lseek(file,(long)(curr_rm*sizeof(struct quickroom)),0);
	b=read(file,&quickroom,sizeof(struct quickroom));
	if (b<1) interr(82);
	quickroom.QRhighest=0L;
	for (a=0; a<MSGSPERRM; ++a)
		if (fullroom.FRnum[a]>quickroom.QRhighest)
			quickroom.QRhighest=fullroom.FRnum[a];
	lseek(file,(long)(curr_rm*sizeof(struct quickroom)),0);
	b=write(file,&quickroom,sizeof(struct quickroom));
	if (b<1) interr(83);
	close(file);
	printf("Message deleted.\n");
	return(0);
}

logoff(code) /* exit program */
int code; {
	unlink(temp); /* remove temporary file */
	setsane();    /* return the old terminal settings */
	exit(code);   /* exit with the proper exit code */
}
