#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include "citadel.h"

/* Citadel/UX filedir utilities.
 * The software assumes that if a user has root access than he/she is
 * allowed to use the filedir utilities. Make sure that the permissions
 * are correct for this.
 */
long atol;

#ifdef BSD
#undef toupper
#undef _toupper
toupper(c)
int c; {return(islower(c)?c-'a'+'A':c);}
#undef tolower
#undef _tolower
tolower(c)
int c; {return(isupper(c)?c-'A'+'a':c);}
#endif BSD

main(argc,argv) 
int argc;
char *argv[];
{
int a,file;
char aaa[100],room[100];
strcpy(room,"None");

MAINMENU:
system("clear");
printf("\n\n");
printf("Citadel/UX File Comments Utilities\n");
printf("Current room directory: %s\n\n",room);
printf(" 1. Select directory room\n");
printf(" 2. List all file comments\n");
printf(" 3. Delete a file comment\n");
printf(" 4. Attach a file comment\n");
printf(" 5. Modify a file comment\n");
printf(" 6. Quit\n");
printf(" Please enter your selection: ");
	gets(aaa);
	a=atoi(aaa);
	if (a==1) goto getroom;
	if (a==2) list(room);
	if (a==3) delete(room);
	if (a==4) attach(room);
	if (a==5) modify(room);
	if (a==6) exit(0);
	goto MAINMENU;

getroom:

printf(" Name of directory room? ");
gets(aaa);
sprintf(room,"./files/%s/filedir",aaa);
file=open(room,O_RDONLY);
if (file<0) {
	printf("No directory file available.\n");
	goto MAINMENU; }
close(file);
goto MAINMENU;
}

list(room)
char room[];
{
int a,file;
char aaa[10];
struct filecomment filecomment;

	file=open(room,O_RDONLY);
	if (file<0) return(1);
	printf("\n");
	printf("File                  Comment\n");
	printf("--------------------  -------\n");

A:	a=read(file,&filecomment,sizeof(struct filecomment));
	if (a<1) goto END;
	printf("%-20s  %s\n", filecomment.FCname, filecomment.FCcomment);
	goto A;

END:	close(file);
	printf("Press <return> to continue");
	gets(aaa);
	return(0);
}


delete(room)
char room[];
{
	struct filecomment filecomment;
	int file,file2,a,b,flag;
	char aaa[150],name[20];

	file=open(room,O_RDONLY);
	if (file<0) return(1);
	printf(" Enter file name: ");
	gets(name);

	sprintf(aaa,"%s.new",room);
	file2=creat(aaa,0666);
	if (file2<0) {
		printf("Can't open the new file.\n");
		close(file);
	return(2); }

	flag=0;
A:	a=read(file,&filecomment,sizeof(struct filecomment));
	if (a<1) goto END;
	if (!strucmp(name,filecomment.FCname)) goto B;
	b=write(file2,&filecomment,sizeof(struct filecomment));
	if (b<1) printf("Can't rewrite!!!\n");
	goto A;

B:	printf(" %s removed\n",
		filecomment.FCname);
	flag=1;
	goto A;

END:	close(file);
	close(file2);

	if (flag) {
	sprintf(aaa,"mv %s.new %s",room,room);
	system(aaa);
	sprintf(aaa,"chmod 666 %s",room);
	system(aaa);
	return(0);
	} else {
	printf(" %s not found.\n",name);
	sprintf(aaa,"rm %s.new",room);
	system(aaa);
	}
	return(3);
}

attach(room)
char room[];
{
	struct filecomment filecomment;
	int file,file2,a,b;
	char aaa[150],name[20],comment[151];

	file=open(room,O_RDONLY);
	if (file<0) return(1);
	printf(" Enter file name: ");
	gets(name);
	printf(" Enter short comment: ");
	gets(comment);

	sprintf(aaa,"%s.new",room);
	file2=creat(aaa,0666);
	if (file2<0) {
		printf("Can't open the new file.\n");
		close(file);
	return(2); }
	
A:	a=read(file,&filecomment,sizeof(struct filecomment));
	if (a<1) goto END;
	b=write(file2,&filecomment,sizeof(struct filecomment));
	if (b<1) printf("Can't rewrite!!!\n");
	goto A;

END:	close(file);
	strcpy(filecomment.FCname,name);
	strcpy(filecomment.FCcomment,comment);
	write(file2,&filecomment,sizeof(struct filecomment));
	close(file2);

	sprintf(aaa,"mv %s.new %s",room,room);
	system(aaa);
	sprintf(aaa,"chmod 666 %s",room);
	system(aaa);
	return(0);
}

modify(room)
char room[];
{
	struct filecomment filecomment;
	int file,file2,a,b,flag;
	char aaa[150],name[20],comment[151];

	file=open(room,O_RDONLY);
	if (file<0) return(1);
	printf(" Enter file name: ");
	gets(name);

	sprintf(aaa,"%s.new",room);
	file2=creat(aaa,0666);
	if (file2<0) {
		printf("Can't open the new file.\n");
		close(file);
	return(2); }

	flag=0;
A:	a=read(file,&filecomment,sizeof(struct filecomment));
	if (a<1) goto END;
	if (!strucmp(name,filecomment.FCname)) goto B;
	b=write(file2,&filecomment,sizeof(struct filecomment));
	if (b<1) printf("Can't rewrite!!!\n");
	goto A;

B:	printf(" %s\n",filecomment.FCcomment);
	printf(" Enter new comment: ");
	gets(comment);
	strcpy(filecomment.FCcomment,comment);
	write(file2,&filecomment,sizeof(struct filecomment));
	flag=1;
	goto A;

END:	close(file);
	close(file2);
	if (flag) {
	sprintf(aaa,"mv %s.new %s",room,room);
	system(aaa);
	sprintf(aaa,"chmod 666 %s",room);
	system(aaa);
	return(0);
	} else {
	printf(" %s not found.\n",name);
	sprintf(aaa,"rm %s.new",room);
	system(aaa);
	}
	return(3);
}

strucmp(st1,st2)
char *st1;
char *st2; {
	char aaa[100],bbb[100];
	int a;
	strcpy(aaa,st1);
	strcpy(bbb,st2);
	for (a=0; a<strlen(aaa); ++a)
		aaa[a]=tolower(aaa[a]);
	for (a=0; a<strlen(bbb); ++a)
		bbb[a]=tolower(bbb[a]);
	a=strcmp(aaa,bbb);
	return(a);
}
