/*
 * netproc v1.1
 * 08/01/88 AJC
 *
 * Inbound message processor has been rewritten completely. It uses
 * a shell command to do all the dirty work of getting each file in the
 * spoolin (inbound) directory. Also, the
 * use table (prevmsgs) now takes the form of a function call. Lastly, the
 * program now checks for an "I" (local origination message ID) field to use
 * in the table, rather than message time. If no I field is present, the
 * message time is still used.
 *   The outbound side has been modified so it will not send a system its
 * own messages.
 */

#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include "citadel.h"

long atol();
long lseek();

struct minfo {
	char N[10];
	long T;
	char A[30];
	char O[20];
	char R[30];
	long I;
	};

main(argc,argv)
int argc;
char *argv[];
{
	if (argc==2) outprocess(argv[1]);
	inprocess();
	exit(0);
}

inprocess() {	/* Process incoming files in ./network/spoolin */
	FILE *fp,*message;
	struct minfo minfo;
	struct recentmsg recentmsg;
	struct smreturn smreturn;
	char tname[50],aaa[100],iname[50];
	int a;

	sprintf(tname,"/tmp/np%d",getpid());	/* temp file name */
	sprintf(iname,"/tmp/ib%d",getpid());	/* temp file name */

	/* Let the shell do the dirty work. Get ALL data from spoolin */
	sprintf(aaa,"cat network/spoolin/* >%s </dev/null",iname);
	system(aaa); system("rm network/spoolin/*");
	fp=fopen(iname,"r");

NXMSG:	/* Break out the next message */
	do {
		a=getc(fp);
		} while((a!=255)&&(a>=0));
	if (a<0) goto ENDSTR;
	message=fopen(tname,"w");
	putc(255,message);
ZFLD:	do {
		a=getc(fp);
		putc(a,message);
		} while(a!=0);
	a=getc(fp);
	putc(a,message);
	if (a!='M') goto ZFLD;
	do {
		a=getc(fp);
		putc(a,message);
		} while(a>0);
	fclose(message);

	/* process the individual mesage */
	msgfind(tname,&minfo);
	recentmsg.RMnum=minfo.I;
	strcpy(recentmsg.RMnodename,minfo.N);
	if (usetable(&recentmsg)!=0) goto SKMSG;
	send_message(tname,&smreturn);
	file_message(minfo.O,&smreturn);
fprintf(stderr,"#%10ld from %s in %s) @ %s\n",minfo.I,minfo.A,minfo.O,minfo.N);

SKMSG:	unlink(tname);
	goto NXMSG;

ENDSTR:	fclose(fp);
	unlink(iname);
	return(0);
}

usetable(msg)		/* check use table	   */
struct recentmsg *msg;	/* returns 0 if ok to post */
	{
	int file3,a;
	struct recentmsg recent2;

	if (msg->RMnum<=0L) return(2);	/* can't use garbage ID's */
	file3=open("./network/prevmsgs",O_RDONLY);
	for (a=0; a<PREVMSGS; ++a) {
		read(file3,&recent2,sizeof(struct recentmsg));
		if ((!strucmp(msg->RMnodename,recent2.RMnodename))
			&&(msg->RMnum==recent2.RMnum)) {
				close(file3);
				return(1);
				}
		}
	close(file3);
	file3=open("./network/prevmsgs.pos",O_RDWR);
	read(file3,&a,2);
	++a; if (a==PREVMSGS) a=0;
	lseek(file3,0L,0);
	write(file3,&a,2);
	close(file3);
	file3=open("./network/prevmsgs",O_RDWR);
	lseek(file3,(long)(a*sizeof(struct recentmsg)),0);
	write(file3,msg,sizeof(struct recentmsg));
	close(file3);
	return(0);
}


msgfind(msgfile,buffer)
char *msgfile;
struct minfo *buffer;
	{
	struct tm *tm;
	int a,b,c,d,e,real,old,mtype,aflag;
	char aaa[100],bbb[100],ttm[3];
	FILE *fp;
		
	fp=fopen(msgfile,"rb");
	if (fp==NULL) {
			fprintf(stderr,"Can't open message file\n");
			return(1); }
	e=getc(fp);
	if (e!=255) {
		fprintf(stderr,"Incorrect message format\n");
		goto END; }
	mtype=getc(fp); aflag=getc(fp);
	buffer->I=0L;

BONFGM:	b=getc(fp); if (b<0) goto END;
	if (b=='M') goto END;
	fpgetfield(fp,bbb);
	if (b=='A') strcpy(buffer->A,bbb);
	if (b=='O') strcpy(buffer->O,bbb);
	if (b=='N') strcpy(buffer->N,bbb);
	if (b=='R') strcpy(buffer->R,bbb);
	if (b=='T') buffer->T=atol(bbb);
	if (b=='I') buffer->I=atol(bbb);
	goto BONFGM;

END:	if (buffer->I==0L) buffer->I=buffer->T;
	fclose(fp);
	return(0);
}

fpgetfield(fp,string)
FILE *fp;
char string[];
{
int a,b,c;
strcpy(string,"");
a=0;
GFXYZAF:
	b=getc(fp);
	if (b<1) { string[a]=0; return(0); }
	string[a]=b;
	++a;
	if (b!=0) goto GFXYZAF;
}

send_message(filename,retbuf)	/* send a message to the master file */
char filename[];		/* tempfilename of proper message */
struct smreturn *retbuf;	/* return information */
{
int file,a,b,c,d,e,file2;
long aa,bb,cc,dd,ee,templen,hibytes,origpos,ffsource;
char aaa[100];
struct msgmain msgmain;

do {
	file=open("./MMstructure",O_RDWR);
	a=read(file,&msgmain,sizeof(struct msgmain));
	close(file);
		} while ( (msgmain.MMflags & MM_BUSY) !=0 );

	
	file=open("./MMstructure",O_RDWR);
	msgmain.MMflags=(msgmain.MMflags|MM_BUSY);
	a=write(file,&msgmain,sizeof(struct msgmain));
	close(file);
	origpos=msgmain.MMcurpos;

/* measure the message and count FF bytes */
ffsource=0L;
file=open(filename,O_RDONLY);
templen=0L;
do {
	a=0; b=read(file,&a,1);
	if (a==255) ++ffsource;
	templen=templen+(long)b;
	} while (b!=0);
close(file);

/* check for FF bytes */
hibytes=0L;
file=open("./msgmain",O_RDWR);
bb=lseek(file,msgmain.MMcurpos,0);

cc=lseek(file,0L,1);
for (bb=0L; bb<templen; ++bb) {
	if (cc>=MM_FILELEN) cc=lseek(file,0L,0);
	c=0; read(file,&c,1); ++cc;
	if (c>127) ++hibytes;		/* bump count if hi bit set */
	}

msgmain.MMlowest=msgmain.MMlowest+hibytes;
msgmain.MMhighest=msgmain.MMhighest+ffsource;

cc=lseek(file,msgmain.MMcurpos,0);
file2=open(filename,O_RDONLY);
cc=lseek(file,0L,1);
for (bb=0L; bb<templen; ++bb) {
	if (((long)cc)>=((long)MM_FILELEN)) cc=lseek(file,0L,0);
	read(file2,&b,1); 
	write(file,&b,1); ++cc;
	}
msgmain.MMcurpos=lseek(file,0L,1);
close(file2);	/* done with temp file */
close(file);	/* done with master file */

/* now update the message structure */
msgmain.MMflags=msgmain.MMflags & ~MM_BUSY;
file=open("./MMstructure",O_RDWR);
a=write(file,&msgmain,sizeof(struct msgmain));
close(file);

retbuf->smnumber=msgmain.MMhighest;
retbuf->smpos=origpos;
return(0);
}

strucmp(st1,st2)
char *st1;
char *st2;
{
char aaa[100],bbb[100];
int a;
	strcpy(aaa,st1); strcpy(bbb,st2);
	for (a=0; a<strlen(aaa); ++a) aaa[a]=tolower(aaa[a]);
	for (a=0; a<strlen(bbb); ++a) bbb[a]=tolower(bbb[a]);
	a=strcmp(aaa,bbb);
	return(a);
}

getline(buffer,file)
char buffer[];
int file; {
	int a,b,c;
	c=0; b=0;
	do {
		a=read(file,&b,1);
		if (b==10) b=0;
		if (a<1) b=0;
		buffer[c]=b; ++c; } while(b!=0);
	return(c-1);
}

pull_message(spos,file2) /* Pull a message out of the master file */
long spos; /* position in master file */
int file2; /* file to write to */
{
	int a,b,c,old,new;
	int file;
	long aa,bb,cc;
	char aaa[100];


	file=open("msgmain",O_RDONLY);
	lseek(file,spos,0);

	old=1; new=1;

A:	old=new; new=0;
	a=read(file,&new,1);
	write(file2,&new,1);

	if ((new=='M')&&(old==0)) goto B;
	goto A;

B:	cc=lseek(file,0L,1);
C:	if (cc>=MM_FILELEN) cc=lseek(file,0L,0);
	c=0; read(file,&c,1); ++cc;
	write(file2,&c,1);
	if (c!=0) goto C;

	close(file);
	return(0);
}
	
outprocess(sysname) /* send new room messages to sysname */
char *sysname;
{
	int a,b,c,roomnum,file,file2,file3,file4;
	long aa,bb,cc,lastseen;
	char aaa[300],bbb[300],spflname[100],tfname[50],sysflname[100];
	char roomname[50];
	char xroom[50],xsys[50];
	struct quickroom quickroom;
	struct fullroom fullroom;
	
	sprintf(sysflname,"network/systems/%s",sysname);
	file=open(sysflname,O_RDONLY);
	if (file<0) {
		fprintf("netproc: no system %s\n",sysname);
		return(1); }
	close(file);
	file=open("network/currmsg",O_RDONLY);
	read(file,&a,2); close(file); ++a;
	file=creat("network/currmsg",0666);
	chmod("network/currmsg",0666);
	write(file,&a,2); close(file);
	sprintf(spflname,"/tmp/%s.%d",NODENAME,a);
	file=creat(spflname,0666);
	chmod(spflname,0666);
	sprintf(tfname,"/tmp/nt%d",a);
	file2=creat(tfname,0666);
	chmod(tfname,0666);
	file3=open(sysflname,O_RDONLY);

	getline(aaa,file3);
	sprintf(bbb,"%s\n",aaa);	/* copy uucp command to temp file */
	write(file2,bbb,strlen(bbb));

NXRM:	/* get the next room off the list */
	a=getline(roomname,file3);
	if (a==0) goto FINISHED;
	sprintf(bbb,"%s\n",roomname);	/* copy it to the temp file */
	write(file2,bbb,strlen(bbb));
	getline(aaa,file3);
	lastseen=atol(aaa);

	/* look for the room in the local file */
	roomnum=(-1);
	file4=open("quickroom",O_RDONLY);
	for (a=0; a<MAXROOMS; ++a) {
		read(file4,&quickroom,sizeof(struct quickroom));
		if (!strucmp(quickroom.QRname,roomname)) roomnum=a;
		}
	close(file4);
	if (roomnum==(-1)) {
		fprintf(stderr,"netproc: no local room %s\n",roomname);
		goto NXRM;
		}
	sprintf(aaa,"./rooms/fullrm%d",roomnum);
	file4=open(aaa,O_RDONLY);
	read(file4,&fullroom,sizeof(struct fullroom));
	close(file4);
	
	/* go thru fullroom list, sending all new messages */
	for (a=0; a<MSGSPERRM; ++a) {
if (fullroom.FRnum[a]!=0L) b=check_message(fullroom.FRpos[a],xroom,xsys);
		
		if ((fullroom.FRnum[a]>lastseen)&&(strucmp(xsys,sysname))) {
			pull_message(fullroom.FRpos[a],file);
			lastseen=fullroom.FRnum[a];
			}
		}
	sprintf(aaa,"%ld\n",lastseen);
	write(file2,aaa,strlen(aaa));
	goto NXRM;

FINISHED:	/* finished spooling new messages */
	close(file);
	close(file2);
	close(file3);

	/* copy temporary sys file into permanent sys file */
	file2=open(tfname,O_RDONLY);
	file3=creat(sysflname,0666);
	chmod(sysflname,0666);
	do {
		b=0; a=read(file2,&b,1);
		if (a>0) write(file3,&b,1);
		} while(a>0);
	close(file2);
	close(file3);
	unlink(tfname);
	file3=open(sysflname,O_RDONLY);
	getline(aaa,file3);
	close(file3);
	sprintf(bbb,aaa,spflname);
	system(bbb);
	unlink(spflname);
	return(0);
}

check_message(pos,xroom,xsys)	/* get room and system of message */
long pos;
char xroom[];
char xsys[]; {
	FILE *fp;
	int a;

	strcpy(xroom,"");
	strcpy(xsys,"");
	fp=fopen("msgmain","r");
	if (fp==NULL) return(1);
	fseek(fp,pos,0);

CMCZ:	do {
		a=getc(fp);
		if (a<0) {
			fclose(fp);
			return(2);
			}
		} while(a!=0);
CMCN:	a=getc(fp);
	if (a=='M') {
			fclose(fp);
			return(0);
			}
	if (a=='O') fpgetfield(fp,xroom);
	if (a=='N') fpgetfield(fp,xsys);
	if ((a=='O')||(a=='N')) goto CMCN;
	goto CMCZ;
}

file_message(room,where)
char room[];
struct smreturn *where; {
	struct quickroom quickroom;
	struct fullroom fullroom;
	int rmnum,a,file;
	char frname[50];

	rmnum=2;
	file=open("quickroom",O_RDWR);
	for (a=0; a<MAXROOMS; ++a) {
		read(file,&quickroom,sizeof(struct quickroom));
		if (!strucmp(quickroom.QRname,room)) rmnum=a;
		}
	lseek(file,(long)(rmnum*sizeof(struct quickroom)),0);
	read(file,&quickroom,sizeof(struct quickroom));
	quickroom.QRhighest=where->smnumber;
	lseek(file,(long)(rmnum*sizeof(struct quickroom)),0);
	write(file,&quickroom,sizeof(struct quickroom));
	close(file);
	sprintf(frname,"./rooms/fullrm%d",rmnum);
	file=open(frname,O_RDWR);
	read(file,&fullroom,sizeof(struct fullroom));
	for (a=0; a<(MSGSPERRM-1); ++a) {
		fullroom.FRnum[a]=fullroom.FRnum[a+1];
		fullroom.FRpos[a]=fullroom.FRpos[a+1];
		}
	fullroom.FRnum[MSGSPERRM-1]=where->smnumber;
	fullroom.FRpos[MSGSPERRM-1]=where->smpos;
	lseek(file,0L,0);
	write(file,&fullroom,sizeof(struct fullroom));
	close(file);
	return(0);
}
