/* Citadel/UX room-oriented routines */

#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#ifdef BSD
#undef toupper
#undef tolower
#endif BSD
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <pwd.h>
#include <setjmp.h>
#ifndef	BSD
#include <termio.h>
#endif	!BSD
#include "citadel.h"

#define IFEXPERT if (usersupp.flags&US_EXPERT)
#define IFNEXPERT if ((usersupp.flags&US_EXPERT)==0)
#define IFAIDE if (usersupp.flags&US_AIDE)
#define IFNAIDE if ((usersupp.flags&US_AIDE)==0)

long atol();
long lseek();
long finduser();

extern int curr_rm;
extern int ugnum;
extern long uglsn;
extern struct quickroom quickroom;
extern struct usersupp usersupp;
extern struct fullroom fullroom;

knrooms(USgiven)
struct usersupp *USgiven;
{
	int a,b,c,d,file;
	struct quickroom QRscratch;

	b=1;
	printf("\n   Rooms with unread messages:\n");
	file=open("./quickroom",O_RDONLY); if (file<0) return(1);
	for (a=0; a<MAXROOMS; ++a) {
		c=read(file,&QRscratch,sizeof(struct quickroom));
		if (c<1) interr(58);
		if (a==1) QRscratch.QRhighest=USgiven->mailnum[MAILSLOTS-1];
		if ((QRscratch.QRflags & QR_INUSE)
			&& (QRscratch.QRhighest> (USgiven->lastseen[a]) )
			&& ( (a!=2) || ((USgiven->flags&US_AIDE)==US_AIDE) )
			&& (QRscratch.QRgen != (USgiven->forget[a]) )
			&& (	((QRscratch.QRflags&QR_PRIVATE)==0)
   			||	(((USgiven->flags)&US_AIDE)==US_AIDE)
   			||	(QRscratch.QRgen==(USgiven->generation[a]))
   		)
		) {
		d=b+strlen(QRscratch.QRname)+3;
		if (d>=(USgiven->screenwidth)) {
			printf("\n"); b=1; }
		c='>'; if (QRscratch.QRflags&QR_DIRECTORY) c=']';
		if (QRscratch.QRflags&QR_NETWORK) c=')';
		printf("%s%c  ",QRscratch.QRname,c);
		b=b+strlen(QRscratch.QRname)+3;
		}
	} 
	if (b!=1) printf("\n");

	b=1;
	printf("\n   No unseen messages in:\n");
	lseek(file,0L,0);
	for (a=0; a<MAXROOMS; ++a) {
		c=read(file,&QRscratch,sizeof(struct quickroom));
		if (c<1) return(1);
		if (a==1) QRscratch.QRhighest=USgiven->mailnum[MAILSLOTS-1];
		if ((QRscratch.QRflags & QR_INUSE)
			&& (QRscratch.QRhighest<=USgiven->lastseen[a])
			&& ( (a!=2) || ((USgiven->flags & US_AIDE)==US_AIDE) )
			&& (QRscratch.QRgen != USgiven->forget[a])
			&& (	((QRscratch.QRflags&QR_PRIVATE)==0)
   			||	((USgiven->flags&US_AIDE)==US_AIDE)
   			||	(QRscratch.QRgen==USgiven->generation[a])
   		)
		) {
		d=strlen(QRscratch.QRname)+3+b;
		if (d>=(USgiven->screenwidth)) {
			printf("\n"); b=1; }
		c='>'; if (QRscratch.QRflags&QR_DIRECTORY) c=']';
		if (QRscratch.QRflags&QR_NETWORK) c=')';
		printf("%s%c  ",QRscratch.QRname,c);
		b=b+strlen(QRscratch.QRname)+3;
		}
	}
	if (b!=1) printf("\n");

	close(file);
	return(0);
}

listzrooms(USgiven)		/* list public forgotten rooms */
struct usersupp *USgiven;
{
	int a,b,c,d,file;
	struct quickroom QRscratch;

	b=1;
	printf("\n   Forgotten public rooms:\n");
	file=open("./quickroom",O_RDONLY); if (file<0) return(1);
	for (a=0; a<MAXROOMS; ++a) {
		c=read(file,&QRscratch,sizeof(struct quickroom));
		if (c<1) interr(58);
		if (a==1) QRscratch.QRhighest=USgiven->mailnum[MAILSLOTS-1];
		if ((QRscratch.QRflags & QR_INUSE)
			&& (QRscratch.QRgen == (USgiven->forget[a]) )
			&& ( (a!=2) || ((USgiven->flags&US_AIDE)==US_AIDE) )
			&& (	((QRscratch.QRflags&QR_PRIVATE)==0)
   			||	(((USgiven->flags)&US_AIDE)==US_AIDE)
   			||	(QRscratch.QRgen==(USgiven->generation[a]))
   		)
		) {
		d=b+strlen(QRscratch.QRname)+3;
		if (d>=(USgiven->screenwidth)) {
			printf("\n"); b=1; }
		c='>'; if (QRscratch.QRflags&QR_DIRECTORY) c=']';
		if (QRscratch.QRflags&QR_NETWORK) c=')';
		printf("%s%c  ",QRscratch.QRname,c);
		b=b+strlen(QRscratch.QRname)+3;
		}
	} 
	if (b!=1) printf("\n");
	close(file);
	return(0);
}

editroom() {	/* .<A>ide <E>dit room */
	int file,file2,a,b,c;
	char aaa[50]; long aa;
	struct usersupp tempUS;

	file=open("quickroom",O_RDWR);
	if (file<0) interr(34);
	lseek(file,(long)(curr_rm*sizeof(struct quickroom)),0);
	a=read(file,&quickroom,sizeof(struct quickroom));
	if (a<1) interr(35);
	printf("Room name is currently: %s\n",quickroom.QRname);
	printf("New name <return=same>? ");
	getline(aaa,19);
	if (aaa[0]!=0) strcpy(quickroom.QRname,aaa);
	printf("This is currently a");
	if ((quickroom.QRflags&QR_PRIVATE)==0) printf(" public");
	if (quickroom.QRflags&QR_PRIVATE) printf(" private");
	if (quickroom.QRflags&QR_PASSWORDED) printf(", passworded");
	if (quickroom.QRflags&QR_GUESSNAME) printf(", guessname");
	printf(" room");
	if ((quickroom.QRflags&QR_PASSWORDED)==QR_PASSWORDED)
			printf(", password: %s",quickroom.QRpasswd);
	printf(".\n");
if (quickroom.QRflags&QR_DIRECTORY) {
	printf("Directory room");
	if (quickroom.QRflags&QR_UPLOAD) printf(", uploading allowed");
	if (quickroom.QRflags&QR_DOWNLOAD) printf(", downloading allowed");
	if (quickroom.QRflags&QR_VISDIR) printf(", visible directory");
	printf(".\nDirectory name: %s\n",quickroom.QRdirname); }
if (quickroom.QRflags&QR_ANONONLY)
	printf("Anonymous-only room.\n");

quickroom.QRflags=(quickroom.QRflags|QR_PRIVATE|QR_PASSWORDED|QR_GUESSNAME);
quickroom.QRflags=(quickroom.QRflags|QR_DIRECTORY|QR_UPLOAD|QR_DOWNLOAD);
quickroom.QRflags=(quickroom.QRflags|QR_VISDIR|QR_ANONONLY);
quickroom.QRflags=(quickroom.QRflags|QR_ANON2|QR_NETWORK);
	printf("New room type? <1>pub <2>guessname <3>passwd <4>inv-only : ");
ANRTT:	b=inkey(); b=b-48;
	if ((b<1)||(b>4)) goto ANRTT;
	printf("%d\n",b);
	if (b!=2) quickroom.QRflags=(quickroom.QRflags-QR_GUESSNAME);
	if (b!=3) quickroom.QRflags=(quickroom.QRflags-QR_PASSWORDED);
	if (b==1) quickroom.QRflags=(quickroom.QRflags-QR_PRIVATE);
	if ((quickroom.QRflags&QR_PASSWORDED)==QR_PASSWORDED) {
		printf("<return> or new password: ");
		getline(aaa,9);
		if (aaa[0]!=0) strcpy(quickroom.QRpasswd,aaa); }
	if ((quickroom.QRflags&QR_PRIVATE)==QR_PRIVATE) {
		printf("Cause users to forget room? ");
		if (yesno()==1) {	++quickroom.QRgen;
				if (quickroom.QRgen==100) quickroom.QRgen=10; }
		}

	printf("Directory room? ");
if (yesno()==0) quickroom.QRflags=(quickroom.QRflags-QR_DIRECTORY);
else {
	printf("     Directory name? ");
	getline(quickroom.QRdirname,14);
	printf("  Uploading allowed? ");
if (yesno()==0) quickroom.QRflags=(quickroom.QRflags-QR_UPLOAD);
	printf("Downloading allowed? ");
if (yesno()==0) quickroom.QRflags=(quickroom.QRflags-QR_DOWNLOAD);
	printf("  Visible Directory? ");
if (yesno()==0) quickroom.QRflags=(quickroom.QRflags-QR_VISDIR); }
	printf("Network Room? ");
if (yesno()==0) quickroom.QRflags=(quickroom.QRflags-QR_NETWORK);
	printf("<1>Normal <2>Anon-only <3>Anon-option ? ");
	getline(aaa,1);
	a=atoi(aaa);
if ((a==1)||(a==3)) quickroom.QRflags=(quickroom.QRflags-QR_ANONONLY);
if ((a==1)||(a==2)) quickroom.QRflags=(quickroom.QRflags-QR_ANON2);
	printf("Edit vote list for this room? ");
	if (yesno()==1) roomvotes();
RANSU:	printf("Room aide is currently: ");	/* This is slow :-)	*/
	file2=open("usersupp",O_RDONLY);	/* (gee, thanks a lot!) */
	do {
		a=read(file2,&tempUS,sizeof(struct usersupp));
		} while((a>0)&&(quickroom.QRroomaide!=tempUS.eternal));
	close(file2);
	if (a<1) printf("Unknown\n");
		else printf("%s\n",tempUS.fullname);
	printf("New room aide (RETURN to leave unchanged): ");
	getline(aaa,29);
	if (aaa[0]!=0) {
		file2=open("usersupp",O_RDONLY);
		aa=finduser(file2,aaa);
		read(file2,&tempUS,sizeof(struct usersupp));
		close(file2);
		if (aa==(-1L)) {
			printf("No such user.\n"); goto RANSU; }
		quickroom.QRroomaide=tempUS.eternal;
		}
	printf("\n\nSave changes (y/n)? ");
	if (yesno()==0) {
		lseek(file,(long)(curr_rm*sizeof(struct quickroom)),0);
		b=read(file,&quickroom,sizeof(struct quickroom));
		if (b<1) interr(36);
		close(file); return(0);
		}
	lseek(file,(long)(curr_rm*sizeof(struct quickroom)),0);
	b=write(file,&quickroom,sizeof(struct quickroom));
	close(file);
	if (quickroom.QRflags & QR_DIRECTORY) {
		sprintf(aaa,"mkdir ./files/%s",quickroom.QRdirname);
		system(aaa);
		sprintf(aaa,"./files/%s",quickroom.QRdirname);
		chmod(aaa,0777);
		}
	return(0);
}

readvote() {
	int file,a,b,c;
	char aaa[100];
	struct voteinfo voteinfo;
	file=open("voteinfo",O_RDONLY);
	read(file,&voteinfo,sizeof(struct voteinfo));
	close(file);
	b=0;
	for (a=0; a<NVOTES; ++a)
		if (voteinfo.VIcurrvote[a]>0)
		if (voteinfo.VIcurrvote[a]==quickroom.QRvotegens[a]) b=1;
	if (b==0) {
		printf("No votes available in this room.\n");
		return(0); }
	printf("\n");
	listrmvotes();
RVRPT:	printf("\nEnter vote number (return to abort): ");
	getline(aaa,2);
	if (aaa[0]==0) return(0);
	a=atoi(aaa);
	if ((a<0)||(a>=NVOTES)) goto RVRPT;
	if (voteinfo.VIcurrvote[a]<1) goto RVRPT;
	if (voteinfo.VIcurrvote[a]!=quickroom.QRvotegens[a]) goto RVRPT;
	voteresults(a);
	return(0);
}
	
entervote() {
	int file,a,b,c;
	char aaa[100];
	struct voteinfo voteinfo;

	file=open("./voteinfo",O_RDONLY);
	read(file,&voteinfo,sizeof(struct voteinfo));
	close(file);
	b=0;
	for (a=0; a<NVOTES; ++a)
		if (voteinfo.VIcurrvote[a]>0)
		if (voteinfo.VIcurrvote[a]==quickroom.QRvotegens[a]) b=1;
	if (b==0) {
		printf("No votes available in this room.\n");
		return(0); }
	printf("\n");
	listrmvotes();
EVRPT:	printf("\nEnter vote number (return to abort): ");
	getline(aaa,2);
	if (aaa[0]==0) return(0);
	a=atoi(aaa);
	if ((a<0)||(a>=NVOTES)) goto EVRPT;
	if (voteinfo.VIcurrvote[a]<1) goto EVRPT;
	if (voteinfo.VIcurrvote[a]!=quickroom.QRvotegens[a]) goto EVRPT;
	if (usersupp.votegens[a]==voteinfo.VIcurrvote[a]) {
		printf("You've already taken that vote.\n");
		return(0); }
	getballot(a);
	readyerself();
	usersupp.votegens[a]=voteinfo.VIcurrvote[a];
	writeyerself();
	return(0);
}

ungoto() {
	if (ugnum==(-1)) return(0);
	readyerself();
	curr_rm=ugnum;
	gotocurr();
	usersupp.lastseen[curr_rm]=uglsn;
	writeyerself();
	return(0);
}

download(c)
int c;
{
	int a,b;
	char aaa[100],bbb[100];
	if ((quickroom.QRflags&QR_DIRECTORY)
		&&(quickroom.QRflags&QR_DOWNLOAD)) {
			printf("Enter filename: ");
			getline(aaa,15);
			for (a=0; a<strlen(aaa); ++a) {
				aaa[a]=tolower(aaa[a]);
				if (aaa[a]=='/') aaa[a]='_';
				}
	sprintf(bbb,"files/%s/%s",quickroom.QRdirname,aaa);
	if (c==0) formout(bbb);
#ifdef BSD
	if (c==1) Xdownload(bbb);
#else
	if (c==1) {
		sprintf(aaa,"wcsend %s",bbb);
		system(aaa);
		}
#endif	BSD
	if (c==2) {
		signal(SIGQUIT,SIG_DFL);
		sttybbs(1);
		sprintf(aaa,"cat <%s",bbb);
		system(aaa);
		sttybbs(0);
		}
	}
	else
		printf("Not in this room.\n");
	return(0);
}

roomdir() {
	char aaa[100];
	if ((quickroom.QRflags&QR_DIRECTORY)
	   &&(quickroom.QRflags&QR_VISDIR)) {
		sprintf(aaa,"./files/%s",
		quickroom.QRdirname);
		directory(aaa); }
	else
		printf("Not in this room.\n");
	return(0);
}

invite() {	/* add a user to a private room */
	char aaa[31];
	int file;
	long aa;
	struct usersupp USscratch;
	if ((quickroom.QRflags&QR_PRIVATE)==0) {
		printf("This isn't a private room!\n");
		return(0);
		}
	printf("Name of user? ");
	getline(aaa,30);
	if (aaa[0]==0) return(0);
	file=open("usersupp",O_RDWR);
	if (file<0) interr(38);
	aa=finduser(file,aaa);
	if (aa!=(-1L)) {
		read(file,&USscratch,sizeof(struct usersupp));
		lseek(file,aa,0);
		USscratch.generation[curr_rm]=quickroom.QRgen;
		USscratch.forget[curr_rm]=(-1);
		write(file,&USscratch,sizeof(struct usersupp));
		}
	else	printf("No such user.\n");
	close(file);
	return(0);

}

kickout() {	/* kick a user out of a private room */
	int file;
	char aaa[100];
	long aa;
	struct usersupp USscratch;
	if ((quickroom.QRflags&QR_PRIVATE)==0) {
		printf("This isn't a private room!\n");
		return(0); }
	printf("Name of user? ");
	getline(aaa,30);
	file=open("usersupp",O_RDWR);
	if (file<0) interr(40);
	aa=finduser(file,aaa);
	if (aa!=(-1L)) {
		read(file,&USscratch,sizeof(struct usersupp));
		lseek(file,aa,0);
		USscratch.generation[curr_rm]=(-1);
		write(file,&USscratch,sizeof(struct usersupp));
		}
	else	printf("No such user.\n");
	close(file);
	return(0);
}

killroom() {	/* aide command: kill the current room */
	int file;
	long aa;
	if (curr_rm<3) { printf("Can't kill this room.\n"); return(0); }
	printf("Are you sure you want to kill this room? ");
	if (yesno()==0) return(0);
	file=open("quickroom",O_RDWR); if (file<0) interr(42);
	aa=(long)curr_rm*sizeof(struct quickroom);
	lseek(file,aa,0);
	quickroom.QRflags=0;
	write(file,&quickroom,sizeof(struct quickroom));
	close(file);
	curr_rm=0;		/* then goto the lobby */
	gotocurr();
	return(0);
}

forget() {	/* forget the current room */
	if (curr_rm<3) {
		printf("You can't forget this room.\n");
		return(0);
		}
	IFAIDE { printf("Aides can't forget rooms.\n"); return(0); }
	printf("Are you sure you want to forget this room? ");
	if (yesno()==0) return(0);
	readyerself();
	usersupp.forget[curr_rm]=quickroom.QRgen;
	usersupp.generation[curr_rm]=(-1);
	writeyerself();
	curr_rm=0;		/* then goto the lobby */
	gotocurr();
	return(0);
}

entroom() {
	int a,b,c,d,file;
	char aaa[100],bbb[100];
	long aa,bb,cc,dd;
	struct quickroom QRscratch;

	printf("Name for new room? ");
	getline(aaa,19);
	if (strlen(aaa)==0) return(0);
	aaa[19]=0;
	strcase(aaa);
	file=open("quickroom",O_RDONLY); if (file<0) interr(62);
	b=0;
	for (a=0; a<MAXROOMS; ++a) {
		c=read(file,&QRscratch,sizeof(struct quickroom));
		if (c<1) interr(63);
		if ( (QRscratch.QRflags & QR_INUSE)
			&& (!strucmp(QRscratch.QRname,aaa)) ) b=1; }
	close(file);
	if (b==1) {
		printf("There is already a room by that name.\n");
		return(0); }
	bb=(-1L);	
	file=open("quickroom",O_RDONLY); if (file<0) interr(64);
	for (a=0; a<MAXROOMS; ++a) {
		cc=lseek(file,0L,1);
		c=read(file,&QRscratch,sizeof(struct quickroom));
		if (c<1) interr(65);
		if (((QRscratch.QRflags&QR_INUSE)==0)&&(bb==(-1L))) bb=cc;
		}
	close(file);
	if (bb==(-1L)) {
		printf("Sorry, no space is available for another room.\n");
		return(0); }
	IFNEXPERT formout("messages/roomaccess");
ACSEL:	printf("<?>Help\n<1>Public room\n<2>Guess-name room\n");
	printf("<3>Passworded room\n<4>Invitation-only room\n");
	printf("Enter room type: ");
ACSE2:	b=inkey(); b=tolower(b);
	if (b=='?') { printf("?\n");
		formout("messages/roomaccess"); goto ACSEL; }
	b=b-48;
	if ((b<1)||(b>4)) goto ACSE2;
	if (b==3) {
		printf("Enter a room password: ");
		getline(bbb,9); }
	printf("%d\n\042%s\042, a",b,aaa);
	if (b==1) printf(" public room.");
	if (b==2) printf(" guess-name room.");
	if (b==3) printf(" passworded room, password: %s",bbb);
	if (b==4) printf("n invitation-only room.");
	printf("\nInstall it? (y/n) : ");
	a=yesno();
	if (a==0) return(0);
	curr_rm=(int)(bb/sizeof(struct quickroom)); 
	file=open("quickroom",O_RDWR);
	if (file<0) interr(66);
	dd=lseek(file,bb,0);
	d=read(file,&quickroom,sizeof(struct quickroom));
	if (d<1) interr(67);
	strcpy(quickroom.QRname,aaa);
	strcpy(quickroom.QRpasswd,"");
	if (b==3) strcpy(quickroom.QRpasswd,bbb);
	quickroom.QRroomaide=(-1L);
	quickroom.QRhighest=0L;
	++quickroom.QRgen; if (quickroom.QRgen==100) quickroom.QRgen=10;
	quickroom.QRflags=QR_INUSE;
	if (b>1) quickroom.QRflags=(quickroom.QRflags|QR_PRIVATE);
	if (b==2) quickroom.QRflags=(quickroom.QRflags|QR_GUESSNAME);
	if (b==3) quickroom.QRflags=(quickroom.QRflags|QR_PASSWORDED);
	if ((b>2)&&(CREATAIDE==1)) quickroom.QRroomaide=usersupp.eternal;
	dd=lseek(file,bb,0);
	write(file,&quickroom,sizeof(struct quickroom));
	close(file);

	/* Initialize a blank fullroom structure */
	for (a=0; a<MSGSPERRM; ++a) {
		fullroom.FRnum[a]=0L;
		fullroom.FRpos[a]=0L;
		}

	sprintf(aaa,"./rooms/fullrm%d",curr_rm);
	file=open(aaa,O_RDWR);
	if (file<0) interr(70);
	write(file,&fullroom,sizeof(struct fullroom));
	close(file);
	gotocurr();
	return(0);
}

gotocurr() /* goto room currently in global variable curr_rm */
{
	int file,a,b,c,d,e; char aaa[100];
	file=open("quickroom",O_RDONLY); if (file<0) interr(74);
		lseek(file,(long)(curr_rm*sizeof(struct quickroom)),0);
		d=read(file,&quickroom,sizeof(struct quickroom));
		if (d<1) interr(75);
	close(file);
	if (curr_rm==1) { readmail(); return(0); }
	sprintf(aaa,"./rooms/fullrm%d",curr_rm);
	file=open(aaa,O_RDONLY); if (file<0) interr(76);
	d=read(file,&fullroom,sizeof(struct fullroom));
	if (d<1) interr(77);
	close(file);
	return(0);
}

listrmvotes() { /* display vote list for this room */
	int a,b,c,file,file2,z;
	char aaa[200];
	struct voteinfo VItemp;
	file=open("voteinfo",O_RDONLY);
	read(file,&VItemp,sizeof(struct voteinfo));
	close(file);
	printf("Number   Description\n");
	printf("------ --------------------\n");
	for (a=0; a<NVOTES; ++a) {
		if (VItemp.VIcurrvote[a]>0)
		if (VItemp.VIcurrvote[a]==quickroom.QRvotegens[a]) {
		sprintf(aaa,"./voting/vote%dobj",a);
		file2=open(aaa,O_RDONLY);
		if (file2<0) strcpy(aaa,"(can't open file)");
		read(file2,&z,2);
		read(file2,aaa,200);
		close(file2);
		printf("%-6d %s\n",a,aaa); } }
	return(0); }

roomvotes()
		/* edit vote list for this room */
	{
	int a,b,c,file,file2,z;
	char aaa[205],bvot[5];
	char bbb[100];
	struct voteinfo VItemp;
RVLV:	file=open("./voteinfo",O_RDONLY);
	read(file,&VItemp,sizeof(struct voteinfo));
	close(file);
	printf("\n\nVote This   Vote\n");
	printf("Num  Room?  name\n");
	printf("---- ---- -----------\n");
	for (a=0; a<NVOTES; ++a) {
		if (VItemp.VIcurrvote[a]>0) {
			sprintf(aaa,"./voting/vote%dobj",a);
			file2=open(aaa,O_RDONLY);
			read(file2,&z,2);
			read(file2,aaa,200);
			close(file2);
if (quickroom.QRvotegens[a]==VItemp.VIcurrvote[a]) strcpy(bvot,"Yes");
						else strcpy(bvot,"No ");
			printf("%-4d %-4s %s\n",a,bvot,aaa);
			}
		}
RVPT:	printf("Number to change (return when finished): ");
	getline(bbb,2);
	if (bbb[0]==0) return(0);
	a=atoi(bbb);
	if ((a<0)||(a>=NVOTES)) {
		printf("Illegal vote number.\n"); goto RVPT; }
	if (VItemp.VIcurrvote[a]<1) {
		printf("Vote %d not in use.\n",a); goto RVPT; }
	if (quickroom.QRvotegens[a]==VItemp.VIcurrvote[a]) {
		quickroom.QRvotegens[a]=(-1L);
		printf("Vote %d removed from list.\n",a);
		goto RVLV; }
	quickroom.QRvotegens[a]=VItemp.VIcurrvote[a];
	printf("Vote %d added to list.\n",a);
	goto RVLV;
}

whoknows() {
	struct usersupp temp;
	int file;
	file=open("usersupp",O_RDONLY);
	if (file<0) return(file);
	while(read(file,&temp,sizeof(struct usersupp))>0) {
	
	if ((       (quickroom.QRflags & QR_PRIVATE)
		&& (quickroom.QRgen==temp.generation[curr_rm])
		&& (quickroom.QRgen!=temp.forget[curr_rm])
		) || (
		    ((quickroom.QRflags & QR_PRIVATE)==0)
		&& (quickroom.QRgen!=temp.forget[curr_rm])
		)) printf("%s\n",temp.fullname);
	}
	close(file);
	return(0);
}
