/* Citadel/UX independent routines (i.e. no global variables are used) */

#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#ifdef BSD
#undef toupper
#undef tolower
#endif BSD
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <pwd.h>
#include <setjmp.h>
#ifdef BSD
#include <sys/dir.h>
#include <sgtty.h>
#else
#include <termio.h>
#endif BSD

#define ROUTINES_C

#include "citadel.h"

#define IFEXPERT if (usersupp.flags&US_EXPERT)
#define IFNEXPERT if ((usersupp.flags&US_EXPERT)==0)
#define IFUPASS if (upass!=0)
#define IFNUPASS if (upass==0)
#define IFAIDE if(((usersupp.flags&US_AIDE)==US_AIDE)||(quickroom.QRroomaide==usersupp.eternal))
#define IFNAIDE if (((usersupp.flags&US_AIDE)==0)&&(quickroom.QRroomaide!=usersupp.eternal))
struct passwd *getpwuid();
struct passwd *getpwnam();
char *getenv();
long atol();
long lseek();

extern char *days[7];
extern char *months[12];

#ifdef BSD
#undef _toupper
toupper(c)
int c; {return(islower(c)?c-'a'+'A':c);}
#undef _tolower
tolower(c)
int c; {return(isupper(c)?c-'A'+'a':c);}
#endif BSD

strucmp(st1,st2) /* Compares two strings without case sensitivity */
char st1[],st2[]; {
char aaa[100],bbb[100];
int a;
	for (a=0; a<=strlen(st1); ++a) aaa[a]=tolower(st1[a]);
	for (a=0; a<=strlen(st2); ++a) bbb[a]=tolower(st2[a]);
	return(strcmp(aaa,bbb));
}

back(spaces) /* Backs up and blanks a certain number of spaces */
int spaces; {
int a;
for (a=1; a<=spaces; ++a) {
                           putc(8,stdout); putc(32,stdout); putc(8,stdout);
                         }
}

yesno() { /* Returns 1 for yes, 0 for no */
int a;
	while (1) {
		a=inkey(); a=tolower(a);
		if (a=='y') { printf("Yes\n"); return(1); }
		if (a=='n') { printf("No\n");  return(0); }
		}
}

edituser(structure)
struct usersupp *structure; {
	int a;
	printf("Problem user [y/n]? ");
	structure->flags=((structure->flags)|US_TWIT);
	if (yesno()==0) structure->flags=((structure->flags)^US_TWIT);
	printf("Deny network privs [y/n]? ");
	structure->flags=((structure->flags)|US_NONET);
	if (yesno()==0) structure->flags=((structure->flags)^US_NONET);
	return(0);
	}

getusinfo(structure)
struct usersupp *structure; {
	int a; char aaa[100];
	do {
		printf("Enter your screen width: ");
		getline(aaa,3); a=atoi(aaa);
		if ((a<20)||(a>132))
			printf("...must be between 20 and 132.\n");
		} while((a<20)||(a>132));
	structure->screenwidth=a;

	printf("Are you an experienced Citadel user? ");
	structure->flags=((structure->flags)|US_EXPERT);
	if (yesno()==0) structure->flags=((structure->flags)^US_EXPERT);

	printf("Print last old message on New message request? ");
	structure->flags=((structure->flags)|US_LASTOLD);
	if (yesno()==0) structure->flags=((structure->flags)^US_LASTOLD);

	if ((structure->flags&US_EXPERT)==0) formout("messages/unlisted");
	printf("List in userlog? ");
	structure->flags=((structure->flags)|US_UNLISTED);
	if (yesno()==1) structure->flags=((structure->flags)^US_UNLISTED);

	printf("Prompt after each message? ");
	structure->flags=((structure->flags)|US_NOPROMPT);
	if (yesno()==1) structure->flags=((structure->flags)^US_NOPROMPT);
}

getfield(file,string)		/* Break out next field from file */
int file; char string[]; {
short int a,b,c;
	strcpy(string,"");
	a=0;
	do {
		c=0; b=read(file,&c,1);
		if (b<1) { string[a]=0; return(0); }
		string[a]=c;
		++a;
		} while(c!=0);
}

#ifdef	BSD
/*
	return number of taboo words
*/
taboo(iname)
char iname[];
{
FILE *fopen(),*fp;
char aaa[30],bbb[30];
int a,taboo;
	if ((fp = fopen("tabooname","r")) == NULL) interr(89);
	taboo=0;
	for (a=0; a<=strlen(iname); ++a) aaa[a]=tolower(iname[a]);
	while (fscanf(fp,"%s",bbb) != EOF) {
		if (bbb[0]=='@') break;
		if (pattern(aaa,bbb)==0) taboo++;
	}
	fclose(fp);
return(taboo);
}
#endif	BSD

pattern(search,patn)	/* Searches for patn in search string */
char search[];
char patn[];
{
	int a,b;
	for (a=0; a<strlen(search); ++a)
	{	b=strncmp(&search[a],patn,strlen(patn));
		if (b==0) return(b);
		}
	return(1);
}


interr(errnum)	/* display internal error as defined in errmsgs */
int errnum; {
int file;
short int a,b,count;
char aaa[2];
	printf("INTERNAL ERROR %d\n",errnum);
	file=open("errmsgs",O_RDONLY);
	if (file>=0) {
		count=0;
		do {
			b=0; a=read(file,&b,1);
			if (b==10) ++count;
			} while ((count<(errnum-1))&&(a==1));
		do {
			b=0; a=read(file,&b,1);
			if ((b!=10)&&(a==1)) printf("%c",b);
			} while((b!=10)&&(a>0));
		printf("\n");
		}
	printf("Please inform the sysop(s) of this error.\n");
	close(file);
	printf("(Press any key to continue)\n");
	inkey();
	logoff(errnum);
}

#ifdef BSD
directory(path)
char *path;
{
struct direct *dp;
struct stat statbuf;
struct filecomment filecomment;
DIR *dirp;
char fname[20],tname[50];
int file,a;
long aa;
	if ((dirp = opendir(path)) == NULL) return(1);
	printf("   Filename      Size\n");
	printf("-------------- --------\n");
	sprintf(tname,"%s/filedir",path);
	file=open(tname,O_RDONLY);
	while ((dp = readdir(dirp)) != NULL) {
		if (*dp->d_name == '.') continue;
		strcpy(fname,dp->d_name);
		if (strcmp("filedir",fname)==0) continue;
		sprintf(tname,"%s/%s",path,fname);
		stat(tname,&statbuf); aa=(long)statbuf.st_size;
		if (file >= 0) {
		lseek(file,0L,0);do {
			a=read(file,&filecomment,sizeof(struct filecomment));
			} while ((a>0)&&(strucmp(filecomment.FCname,fname)));
		} else a=0;
		if (a<1) filecomment.FCcomment[0]=0;
		printf("%-14s %8ld %s\n",fname,aa,filecomment.FCcomment);
	}
	close(file);
	closedir(dirp);
	return(0);
}
#else
directory(path)
char *path;
{
	struct directx {
		int d_ino;
		char d_name[15];
	} dlink;
	struct filecomment filecomment;
	int fd,file,nread,a,b; char tname[100];
	struct stat statbuf; long aa;
	char *dname;
if ((fd=open(path,0))==(-1)) return(1);
dlink.d_name[14]=0;
printf("   Filename      Size\n");
printf("-------------- --------\n");
read(fd,&dlink,16); read(fd,&dlink,16);
while ((nread=read(fd,&dlink,16)) > 0)
	{
	if ((strucmp(dlink.d_name,"filedir"))&&(dlink.d_ino!=0)) {
		sprintf(tname,"%s/%s",path,dlink.d_name);
		stat(tname,&statbuf);
		aa=(long)statbuf.st_size;
		sprintf(tname,"%s/filedir",path);
	filecomment.FCcomment[0]=0;
	file=open(tname,O_RDONLY);
	if (file>=0) do {
	a=read(file,&filecomment,sizeof(struct filecomment));
		} while((a>0)&&(strucmp(filecomment.FCname,dlink.d_name)));
		close(file);
		if (a<1) filecomment.FCcomment[0]=0;
	printf("%-14s %8ld %s\n",dlink.d_name,aa,filecomment.FCcomment);
	}
	}
	close(fd);
	return(0);
}
#endif	BSD

fpgetfield(fp,string)
FILE *fp;
char string[];
{
int a,b;
strcpy(string,"");
a=0;
	do {
		b=getc(fp);
		if (b<1) { string[a]=0; return(0); }
		string[a]=b;
		++a;
		} while(b!=0);
}


getballot(votenum) /* enter your ballot for votenum */
{
	short int a,b,c,d,e,file,nques,nans,choice;
	char aaa[200],bbb[200],ccc[200];
	long aa;

	sprintf(aaa,"./voting/vote%dobj",votenum);
	file=open(aaa,O_RDWR);
	if (file<0) {
		printf("Can't open vote file %s\n",aaa);
		return(2); }

	a=getint(file);
	read(file,aaa,200);
	printf("%s\n",aaa);
	d=getint(file);
	++d;
	lseek(file,(-2L),1);
	write(file,&d,2);
	nques=getint(file);
	for (a=0; a<nques; ++a) {
		nans=getint(file);
		read(file,aaa,200);
		printf("%s\n",aaa);
		aa=lseek(file,0L,1);
		for (b=0; b<nans; ++b) {
			read(file,aaa,100);
			c=getint(file);
			printf("%d. %s\n",
				b+1,aaa);
			}
		do {
			printf("Your choice: ");
			getline(aaa,2); choice=atoi(aaa);
			} while ((choice<=0)||(choice>nans));
		--choice;
		lseek(file,aa,0);
		for (b=0; b<nans; ++b) {
			read(file,aaa,100);
			c=getint(file);
			if (b==choice) {
				++c;
				lseek(file,(-2L),1);
				write(file,&c,2); }
			}
		printf("\n");
		}
	close(file);
	printf("Thanks for your input!\n");
	return(0);
}

fmout(width,flname)
int width;
char flname[];
	{

	int a,b,c,d,e,real,old;
	char aaa[100],bbb[100];
	FILE *fp;
	
	fp=fopen(flname,"rb");
	if (fp==NULL) {
			printf("No file %s.\n",flname);
			return(1); }

	strcpy(aaa,""); old=255;
	c=1; /* c is the current pos */
FMTA:	old=real; a=getc(fp); real=a;
	if (a==0) goto FMTEND;
	if (a<0) goto FMTEND;
	
	if ( ((a==13)||(a==10)) && (old!=13) && (old!=10) ) a=32;
	if ( ((old==13)||(old==10)) && (isspace(real)) ) {
						printf("\n"); c=1; }
	if (a>126) goto FMTA;

	if (a>32) {
	if ( ((strlen(aaa)+c)>(width-5)) && (strlen(aaa)>(width-5)) )
		{ printf("\n%s",aaa); c=strlen(aaa); aaa[0]=0; }
	 b=strlen(aaa); aaa[b]=a; aaa[b+1]=0; }
	if (a==32) { 	if ((strlen(aaa)+c)>(width-5)) { 
							printf("\n");
							c=1;
							}
			printf("%s ",aaa); ++c; c=c+strlen(aaa);
			strcpy(aaa,""); goto FMTA; }
	if ((a==13)||(a==10)) {
				printf("%s\n",aaa); c=1;
				strcpy(aaa,""); goto FMTA; }
	goto FMTA;

FMTEND:	fclose(fp);
	printf("\n");
	return(0);
}

strproc(string)
char string[];
{
	int a,b,c;
	char aaa[100];
	char bbb[5];
	strcpy(aaa,string);

	if (string[0]==0) return(0);
/* Convert non-printable characters to blanks */
	for (a=0; a<strlen(aaa); ++a) {
		if (aaa[a]<32) aaa[a]=32;
		if (aaa[a]>126) aaa[a]=32; }

/* Remove leading and trailing blanks */
	while(aaa[0]<33) strcpy(aaa,&aaa[1]);
	while(aaa[strlen(aaa)-1]<33) aaa[strlen(aaa)-1]=0;

/* Remove double blanks */
	bbb[1]=0;
	strcpy(string,"");
	for (a=0; a<strlen(aaa); ++a) {
		if ((aaa[a]==32)&&(aaa[a+1]==32)) goto PSSKP;
PSNSKP:	bbb[0]=aaa[a];
	strcat(string,bbb);
PSSKP:	bbb[1]=0;
	}
	return(0);
}

#ifdef BSD
sttybbs(sflag) 
int sflag;{
struct sgttyb live;
	ioctl(0,TIOCGETP,&live);
	live.sg_flags |= CBREAK;
	live.sg_flags &= ~ECHO;
	ioctl(0,TIOCSETP,&live);
	return(0);
}
#else
sttybbs(sflag) 
int sflag;{
struct termio live;
	ioctl(0,TCGETA,&live);
	live.c_iflag=ISTRIP|IXON|IXANY;
	live.c_oflag=OPOST|ONLCR;
	live.c_lflag=NOFLSH;
	if (sflag==1) live.c_lflag=ISIG|NOFLSH;
	live.c_line=0;
	live.c_cc[0]=15;
	live.c_cc[1]=3;
	live.c_cc[2]=8;
	live.c_cc[3]=24;
	live.c_cc[4]=1;
	live.c_cc[5]=255;
	live.c_cc[6]=0;
	live.c_cc[7]=0;
	ioctl(0,TCSETA,&live);
	return(0);
}
#endif	BSD

voteresults(votenum) /* display vote results for a vote number */
 {
	short int a,b,c,d,e,file,nques,nans;
	char aaa[200],bbb[200],ccc[200];

	sprintf(aaa,"voting/vote%dobj",votenum);
	file=open(aaa,O_RDONLY);
	if (file<0) {
		printf("Can't open vote file.\n");
		return(2); }

	a=getint(file);
	read(file,aaa,200);
	printf("%s\n",aaa);
	d=getint(file);
	printf("%d people have taken this vote.\n\n",d);
	if (d==0) {
		close(file);
		return(0); }
	read(file,&nques,2);
	for (a=0; a<nques; ++a) {
		nans=getint(file);
		read(file,aaa,200);
		printf("Question: %s\n",aaa);
		for (b=0; b<nans; ++b) {
			read(file,aaa,100);
			c=getint(file);
			printf("%3d (%3d%%) said %s\n",
				c,((c*100)/d),aaa);
			}
		printf("\n");
		}
	close(file);
	return(0);
}

long finduser(file,name)
int file;
char name[];
{
	struct usersupp temp;
	int a;
	long bottom,top,guess,obottom,otop;

	obottom=(-1L); otop=(-1L);
	bottom=0L;
	top=(lseek(file,0L,2)/(long)sizeof(struct usersupp));

while(1) {
	if ((obottom==bottom)&&(otop==top)) return(-1L);
	obottom=bottom; otop=top;
	guess=(((top-bottom)/2)+bottom);
	lseek(file,(guess*(long)sizeof(struct usersupp)),0);
	read(file,&temp,sizeof(struct usersupp));
	a=strucmp(temp.fullname,name);
	if (a==0) return(lseek(file,(guess*(long)sizeof(struct usersupp)),0));
	if (a<0) bottom=guess;
	if (a>0) top=guess;
	}
}

rec_log(record)		/* record an entry in the call log */
struct calllog *record;
{
	int file;
	short int a,b;
	time(&record->CLtime);
	file=open("calllog.pos",O_RDWR);
	a=getint(file);
	b=a; ++a; if (a==CALLLOG) a=0;
	lseek(file,0L,0);
	write(file,&a,2);
	close(file);

	file=open("calllog",O_RDWR);
	lseek(file,(long)(b*sizeof(struct calllog)),0);
	write(file,record,sizeof(struct calllog));
	close(file);
	return(0);
}

#ifdef BSD
log_carr()		/* use rec_log to record the connection */
{
	struct calllog temp;
	struct sgttyb stty;
	temp.CLfullname[0]=0;
	temp.CLflags=CL_INOTHER;
	ioctl(0,TIOCGETP,&stty);
	if ((stty.sg_ispeed&B300)==B300)	temp.CLflags=CL_IN300;
	if ((stty.sg_ispeed&B1200)==B1200)	temp.CLflags=CL_IN1200;
	if ((stty.sg_ispeed&B2400)==B2400)	temp.CLflags=CL_IN2400;
	if ((stty.sg_ispeed&B9600)==B9600)	temp.CLflags=CL_INOTHER;
	rec_log(&temp);
	return(0);
}
#else
log_carr()		/* use rec_log to record the connection */
{
	struct calllog temp;
	struct termio stty;
	strcpy(temp.CLfullname,ttyname(0));
	temp.CLflags=CL_INOTHER;
	ioctl(0,TCGETA,&stty);
	if ((stty.c_cflag&B300)==B300)		temp.CLflags=CL_IN300;
	if ((stty.c_cflag&B1200)==B1200)	temp.CLflags=CL_IN1200;
	if ((stty.c_cflag&B2400)==B2400)	temp.CLflags=CL_IN2400;
	if ((stty.c_cflag&B9600)==B9600)	temp.CLflags=CL_INOTHER;
	rec_log(&temp);
	return(0);
}
#endif	BSD

alias(name)
char name[]; {
	FILE *fp;
	int a,b;
	char aaa[300],bbb[300];
	
	fp=fopen("network/mail.aliases","r");
	if (fp==NULL) return(2);
GNA:	strcpy(aaa,""); strcpy(bbb,"");
	do {
		a=getc(fp);
		if (a==',') a=0;
		if (a>0) { b=strlen(aaa); aaa[b]=a; aaa[b+1]=0; }
		} while(a>0);
	do {
		a=getc(fp);
		if (a==10) a=0;
		if (a>0) { b=strlen(bbb); bbb[b]=a; bbb[b+1]=0; }
		} while(a>0);
	if (a<0) {
		fclose(fp);
		return(1);
		}
	if (strucmp(name,aaa)) goto GNA;
	fclose(fp);
	strcpy(name,bbb);
	printf("*** Mail is being forwarded to %s\n",name);
	return(0);
}

/*
   getint is used in the voteing routines and
   in other places when we need to read a 16 bit
   intager from a data file, to allow VAX or other
   non 16 bit cpu's to work.
 */

getint(file)
int file;
{
#ifdef BSD
	short int a;	/* on a VAX a int is 32 bits */
#else
	int a;		/* on micro's int is 16 bits */
#endif
	read(file,&a,2);
	return(a);
}
