/* Citadel/UX setup program.
 * yo, sysops! Here's how to configure your Citadel/UX system:
 * - edit sysconfig.h, setting NODENAME and MM_FILELEN
 * - compile ALL programs using citadel.h (including this one)
 * - run setup
 * - add in all the other stuff (such as guest accounts in /etc/passwd:
 *                                      see the docs for that)
 * - swear over it until it runs
 *
 */


#include <stdio.h>
#include <ctype.h>
#include <fcntl.h>
#include "citadel.h"

main() {
	int flag;
	char aaa[20];
	printf("system setup/configuration program\r\n");

	flag=0;	
	printf("\n\n\r\nCreate/clear message file? ");
	gets(aaa);
	if ((aaa[0]=='y') || (aaa[0]=='Y')) {
		main1();
		flag++;
	}

printf("\n\n\r\nCreate/clear user file? ");
	gets(aaa);
	if ((aaa[0]=='y') || (aaa[0]=='Y')) main2();

printf("\n\n\r\nCreate/initialize room files? ");
	if (flag==0) gets(aaa);
	if ((aaa[0]=='y') || (aaa[0]=='Y')) main3();

printf("\n\n\r\nCreate/initialize the vote files? ");
	gets(aaa);
	if ((aaa[0]=='y') || (aaa[0]=='Y')) main4();

printf("\n\n\r\nCreate/clear call log? ");
	gets(aaa);
	if ((aaa[0]=='y') || (aaa[0]=='Y')) main5();

	printf("\n\n\r\n%s\r\nSetup finished.\r\n\n",PGMNAME);
	exit(0);
}

main1() {

	struct msgmain msgmain;
	int file,a,b,c;
	FILE *fp;
	long aa,bb,cc,dd,ee;

fp=fopen("msgmain","wb");

for (aa=0; aa<=(MM_FILELEN+100); ++aa) {

putc(0,fp);

if ( (aa % 10000L) == 0L ) printf("Creating msgmain, byte %15ld\r",aa);

}

fclose(fp);

printf("\n\n\r\nSetting global message numbers and unlocking files\r\n\n");

msgmain.MMlowest=10L;
msgmain.MMhighest=10L;
msgmain.MMcurpos=100L;
msgmain.MMflags=0;

fp=fopen("MMstructure","wb");

fwrite(&msgmain,sizeof(struct msgmain),1,fp);

fclose(fp);
}

/* Create the user supplement file */

main2() {

	int a,b,c,file;
	char aaa[100];
	struct usersupp therecord;
	FILE *fp;

	printf("\n\n\r\nCreating user supplement file\r\n");

	fp=fopen("usersupp","wb");
	if (fp==NULL) {
		printf("setup: AAAAAIIIIGGGGHHHH! Can't create file.\n");
		exit(1);
		}
	fclose(fp);
	file=creat("eternal",0666);
	chmod("eternal",0666);
	write(file,"\000\000\000\000",4);
	close(file);
}

main3() {
	int a,b,c,d,e;
	long aa,bb,cc,dd,ee;
	char aaa[100];
	FILE *fp;
	struct quickroom quickroom;
	struct fullroom fullroom;

printf("\n\n\n\r\nCreating and initializing room files...\r\n");

/* Load up a blank fullroom structure to be used for all rooms */
for (a=0; a<MSGSPERRM; ++a) {
	fullroom.FRnum[a]=0L;
	fullroom.FRpos[a]=0L; }

/* Open a new quickroom file */
fp=fopen("quickroom","wb");

/* Load up and write to disk the quickrooms structures for the three
 * major rooms: Lobby>, Mail>, and Aide> 
 */

strcpy(quickroom.QRname,"Lobby");
strcpy(quickroom.QRpasswd,"");
quickroom.QRroomaide= -1L;
quickroom.QRhighest= 0L;
quickroom.QRgen= 1;
quickroom.QRflags= QR_INUSE;
for (a=0; a<NVOTES; ++a) quickroom.QRvotegens[a]=0;
fwrite(&quickroom,sizeof(struct quickroom),1,fp);

strcpy(quickroom.QRname,"Mail");
fwrite(&quickroom,sizeof(struct quickroom),1,fp);

strcpy(quickroom.QRname,"Aide");
fwrite(&quickroom,sizeof(struct quickroom),1,fp);

/* make the remaining rooms blanks */
strcpy(quickroom.QRname,"");
quickroom.QRflags=0;

for (a=3; a<MAXROOMS; ++a) {
	printf("Creating quickroom %d\n",a);
	fwrite(&quickroom,sizeof(struct quickroom),1,fp);
	}
fclose(fp);

/* Create directories and fullroom files */

printf("\n\n\n");
system("mkdir rooms");
system("cd ./rooms");

for (a=0; a<MAXROOMS; ++a) {
	printf("Creating fullroom %d\n",a);
	sprintf(aaa,"./rooms/fullrm%d",a);
	fp=fopen(aaa,"wb");
	fwrite(&fullroom,sizeof(struct fullroom),1,fp);
	fclose(fp);
	system("cd ./rooms");
	}

system("cd .");

}

main4() {
int file,a,b,c;
struct voteinfo voteinfo;

voteinfo.VInextgen=10;
for (a=0; a<NVOTES; ++a) voteinfo.VIcurrvote[a]=(-1);

file=creat("voteinfo",0666);
write(file,&voteinfo,sizeof(struct voteinfo));
close(file);
return(0);
}

main5() {
	int file,a;
	struct calllog calllog;

	calllog.CLfullname[0]=0;
	calllog.CLtime=0L;
	calllog.CLflags=0;
	a=0;

	file=creat("calllog.pos",0666);
	chmod("calllog.pos",0666);
	write(file,&a,2);
	close(file);

	file=creat("calllog",0666);
	chmod("calllog",0666);
	for (a=0; a<CALLLOG; ++a) {
		printf("%5d\r",a);
		write(file,&calllog,sizeof(struct calllog));
		}
	close(file);
	printf("         \n");
	return(0);
}
