#include <stdio.h>
#include <fcntl.h>
#include <sgtty.h>
#include <signal.h>
#include <setjmp.h>

struct sgttyb tty,ttysav;
int ttyfd;
jmp_buf tobuf;

#define SOH             1       /* Start of sector char */
#define EOT             4       /* end of transmission char */
#define ACK             6       /* acknowledge sector transmission */
#define NAK             21      /* error in transmission detected */
#define CAN		24	/* cancel session */
int (*timeout())() {
	longjmp(tobuf,1);
	}

fixterm()
{
    if ((ttyfd = open("/dev/tty",2)) < 0) {   /* Open terminal */
	fprintf(stderr,"wcrecieve: cannot open tty\n");
	exit(0);
    }

    ioctl(ttyfd,TIOCGETP,&tty);   /* Get terminal flags */
    ioctl(ttyfd,TIOCGETP,&ttysav);   /* save a copy */
#ifndef unix
    tty.sg_flags = RAW | TANDEM;
#else
    tty.sg_flags = RAW;
#endif
    ioctl(ttyfd,TIOCSETP,&tty);   /* Save as new characteristics */

}

restoreterm()
{
    ioctl(ttyfd,TIOCSETP,&ttysav);   /* Restore terminal */
    close(ttyfd);   /* Close terminal */
}

getbytes(buffer,nbytes)
char buffer[];
int nbytes; {
	int a,b;
	signal(SIGALRM,(*timeout));
	alarm(10);
	a=setjmp(tobuf);
	if (a!=0) return(-1);
	for (a=0; a<nbytes; ++a) read(ttyfd,&buffer[a],1);
	alarm(0);
	return(nbytes);
	}

main(argc,argv)
int argc;
char *argv[]; {
	int a,b,c,d,file,retries,block;
	char buffer[150];

	if (argc!=2) {
		fprintf(stderr,"wcrecieve: usage: wcrecieve filanme\n");
		exit(1);
		}

	file=creat(argv[1],0666);
	if (file<0) {
		fprintf(stderr,"wcrecieve: cannot create %s\n",argv[1]);
		exit(2);
		}

	fprintf(stderr,"wcrecieve: begin uploading now\n");
	fixterm();

	block=1;
	retries=0;
SHAKE:	a=NAK;
	write(ttyfd,&a,1);
	++retries;

NBLOCK:	a=getbytes(buffer,1);
	if (a==1) goto RHOK;
	if (retries<10) goto SHAKE;
	restoreterm();
	fprintf(stderr,"wcrecieve: transfer timed out\n");
	exit(3);

RHOK:	retries=0;
	if (buffer[0]==EOT) {
		a=ACK;
		write(ttyfd,&a,1);
		close(file);
		restoreterm();
		fprintf(stderr,"wcrecieve: transfer complete\n");
		exit(0);
		}
	if (buffer[0]==CAN) {
		a=ACK;
		write(ttyfd,&a,1);
		close(file);
		restoreterm();
		fprintf(stderr,"wcrecieve: transfer aborted\n");
		exit(4);
		}
	if (buffer[0]!=SOH) goto SHAKE;

GETN:	b=0; c=0; d=0; a=getbytes(&b,1);
	if (a==1) a=a+getbytes(&c,1);
	if (a==2) a=a+getbytes(buffer,128);
	if (a==130) a=a+getbytes(&d,1);
	if (a==131) goto GBOK;
	++retries;
	if (retries<10) goto SHAKE;
	close(file);
	restoreterm();
	fprintf(stderr,"wcrecieve: transfer timed out\n");
	exit(5);

GBOK:	if (b!=(255-c)) goto SHAKE;
	if (b==(block-1)) {
		a=ACK;	
		write(ttyfd,&a,1);
		goto NBLOCK;
		}
	if (b!=block) goto SHAKE;
	b=0;
	for (a=0; a<128; ++a) b=b+buffer[a];
	c=b&0xFF;
	if (c!=d) goto SHAKE;
	write(file,buffer,128);
	a=ACK;
	write(ttyfd,&a,1);
	++block;
	if (block==256) block=0;
	retries=0;
	goto NBLOCK;
	} /* end of main() */
